declare enum ModCallbacks {
  MC_NPC_UPDATE = 0,
  MC_POST_UPDATE = 1,
  MC_POST_RENDER = 2,
  MC_USE_ITEM = 3,
  MC_POST_PEFFECT_UPDATE = 4,
  MC_USE_CARD = 5,
  MC_FAMILIAR_UPDATE = 6,
  MC_FAMILIAR_INIT = 7,
  MC_EVALUATE_CACHE = 8,
  MC_POST_PLAYER_INIT = 9,
  MC_USE_PILL = 10,
  MC_ENTITY_TAKE_DMG = 11,
  MC_POST_CURSE_EVAL = 12,
  MC_INPUT_ACTION = 13,
  // MC_LEVEL_GENERATOR = 14, // Not implemented
  MC_POST_GAME_STARTED = 15,
  MC_POST_GAME_END = 16,
  MC_PRE_GAME_EXIT = 17,
  MC_POST_NEW_LEVEL = 18,
  MC_POST_NEW_ROOM = 19,
  MC_GET_CARD = 20,
  MC_GET_SHADER_PARAMS = 21,
  MC_EXECUTE_CMD = 22,
  MC_PRE_USE_ITEM = 23,
  MC_PRE_ENTITY_SPAWN = 24,
  MC_POST_FAMILIAR_RENDER = 25,
  MC_PRE_FAMILIAR_COLLISION = 26,
  MC_POST_NPC_INIT = 27,
  MC_POST_NPC_RENDER = 28,
  MC_POST_NPC_DEATH = 29,
  MC_PRE_NPC_COLLISION = 30,
  MC_POST_PLAYER_UPDATE = 31,
  MC_POST_PLAYER_RENDER = 32,
  MC_PRE_PLAYER_COLLISION = 33,
  MC_POST_PICKUP_INIT = 34,
  MC_POST_PICKUP_UPDATE = 35,
  MC_POST_PICKUP_RENDER = 36,
  MC_POST_PICKUP_SELECTION = 37,
  MC_PRE_PICKUP_COLLISION = 38,
  MC_POST_TEAR_INIT = 39,
  MC_POST_TEAR_UPDATE = 40,
  MC_POST_TEAR_RENDER = 41,
  MC_PRE_TEAR_COLLISION = 42,
  MC_POST_PROJECTILE_INIT = 43,
  MC_POST_PROJECTILE_UPDATE = 44,
  MC_POST_PROJECTILE_RENDER = 45,
  MC_PRE_PROJECTILE_COLLISION = 46,
  MC_POST_LASER_INIT = 47,
  MC_POST_LASER_UPDATE = 48,
  MC_POST_LASER_RENDER = 49,
  MC_POST_KNIFE_INIT = 50,
  MC_POST_KNIFE_UPDATE = 51,
  MC_POST_KNIFE_RENDER = 52,
  MC_PRE_KNIFE_COLLISION = 53,
  MC_POST_EFFECT_INIT = 54,
  MC_POST_EFFECT_UPDATE = 55,
  MC_POST_EFFECT_RENDER = 56,
  MC_POST_BOMB_INIT = 57,
  MC_POST_BOMB_UPDATE = 58,
  MC_POST_BOMB_RENDER = 59,
  MC_PRE_BOMB_COLLISION = 60,
  MC_POST_FIRE_TEAR = 61,
  MC_PRE_GET_COLLECTIBLE = 62,
  MC_POST_GET_COLLECTIBLE = 63,
  MC_GET_PILL_COLOR = 64,
  MC_GET_PILL_EFFECT = 65,
  MC_GET_TRINKET = 66,
  MC_POST_ENTITY_REMOVE = 67,
  MC_POST_ENTITY_KILL = 68,
  MC_PRE_NPC_UPDATE = 69,
  MC_PRE_SPAWN_CLEAN_AWARD = 70,
  MC_PRE_ROOM_ENTITY_SPAWN = 71,
}

declare enum EntityType {
  ENTITY_NULL = 0,
  ENTITY_PLAYER = 1,
  ENTITY_TEAR = 2,
  ENTITY_FAMILIAR = 3,
  ENTITY_BOMBDROP = 4,
  ENTITY_PICKUP = 5,
  ENTITY_SLOT = 6,
  ENTITY_LASER = 7,
  ENTITY_KNIFE = 8,
  ENTITY_PROJECTILE = 9,
  ENTITY_GAPER = 10,
  ENTITY_GUSHER = 11,
  ENTITY_HORF = 12,
  ENTITY_FLY = 13,
  ENTITY_POOTER = 14,
  ENTITY_CLOTTY = 15,
  ENTITY_MULLIGAN = 16,
  ENTITY_SHOPKEEPER = 17,
  ENTITY_ATTACKFLY = 18,
  ENTITY_LARRYJR = 19,
  ENTITY_MONSTRO = 20,
  ENTITY_MAGGOT = 21,
  ENTITY_HIVE = 22,
  ENTITY_CHARGER = 23,
  ENTITY_GLOBIN = 24,
  ENTITY_BOOMFLY = 25,
  ENTITY_MAW = 26,
  ENTITY_HOST = 27,
  ENTITY_CHUB = 28,
  ENTITY_HOPPER = 29,
  ENTITY_BOIL = 30,
  ENTITY_SPITY = 31,
  ENTITY_BRAIN = 32,
  ENTITY_FIREPLACE = 33,
  ENTITY_LEAPER = 34,
  ENTITY_MRMAW = 35,
  ENTITY_GURDY = 36,
  ENTITY_BABY = 38,
  ENTITY_VIS = 39,
  ENTITY_GUTS = 40,
  ENTITY_KNIGHT = 41,
  ENTITY_STONEHEAD = 42,
  ENTITY_MONSTRO2 = 43,
  ENTITY_POKY = 44,
  ENTITY_MOM = 45,
  ENTITY_SLOTH = 46,
  ENTITY_LUST = 47,
  ENTITY_WRATH = 48,
  ENTITY_GLUTTONY = 49,
  ENTITY_GREED = 50,
  ENTITY_ENVY = 51,
  ENTITY_PRIDE = 52,
  ENTITY_DOPLE = 53,
  ENTITY_FLAMINGHOPPER = 54,
  ENTITY_LEECH = 55,
  ENTITY_LUMP = 56,
  ENTITY_MEMBRAIN = 57,
  ENTITY_PARA_BITE = 58,
  ENTITY_FRED = 59,
  ENTITY_EYE = 60,
  ENTITY_SUCKER = 61,
  ENTITY_PIN = 62,
  ENTITY_FAMINE = 63,
  ENTITY_PESTILENCE = 64,
  ENTITY_WAR = 65,
  ENTITY_DEATH = 66,
  ENTITY_DUKE = 67,
  ENTITY_PEEP = 68,
  ENTITY_LOKI = 69,
  ENTITY_FISTULA_BIG = 71,
  ENTITY_FISTULA_MEDIUM = 72,
  ENTITY_FISTULA_SMALL = 73,
  ENTITY_BLASTOCYST_BIG = 74,
  ENTITY_BLASTOCYST_MEDIUM = 75,
  ENTITY_BLASTOCYST_SMALL = 76,
  ENTITY_EMBRYO = 77,
  ENTITY_MOMS_HEART = 78,
  ENTITY_GEMINI = 79,
  ENTITY_MOTER = 80,
  ENTITY_FALLEN = 81,
  ENTITY_HEADLESS_HORSEMAN = 82,
  ENTITY_HORSEMAN_HEAD = 83,
  ENTITY_SATAN = 84,
  ENTITY_SPIDER = 85,
  ENTITY_KEEPER = 86,
  ENTITY_GURGLE = 87,
  ENTITY_WALKINGBOIL = 88,
  ENTITY_BUTTLICKER = 89,
  ENTITY_HANGER = 90,
  ENTITY_SWARMER = 91,
  ENTITY_HEART = 92,
  ENTITY_MASK = 93,
  ENTITY_BIGSPIDER = 94,
  ENTITY_ETERNALFLY = 96,
  ENTITY_MASK_OF_INFAMY = 97,
  ENTITY_HEART_OF_INFAMY = 98,
  ENTITY_GURDY_JR = 99,
  ENTITY_WIDOW = 100,
  ENTITY_DADDYLONGLEGS = 101,
  ENTITY_ISAAC = 102,
  ENTITY_STONE_EYE = 201,
  ENTITY_CONSTANT_STONE_SHOOTER = 202,
  ENTITY_BRIMSTONE_HEAD = 203,
  ENTITY_MOBILE_HOST = 204,
  ENTITY_NEST = 205,
  ENTITY_BABY_LONG_LEGS = 206,
  ENTITY_CRAZY_LONG_LEGS = 207,
  ENTITY_FATTY = 208,
  ENTITY_FAT_SACK = 209,
  ENTITY_BLUBBER = 210,
  ENTITY_HALF_SACK = 211,
  ENTITY_DEATHS_HEAD = 212,
  ENTITY_MOMS_HAND = 213,
  ENTITY_FLY_L2 = 214,
  ENTITY_SPIDER_L2 = 215,
  ENTITY_SWINGER = 216,
  ENTITY_DIP = 217,
  ENTITY_WALL_HUGGER = 218,
  ENTITY_WIZOOB = 219,
  ENTITY_SQUIRT = 220,
  ENTITY_COD_WORM = 221,
  ENTITY_RING_OF_FLIES = 222,
  ENTITY_DINGA = 223,
  ENTITY_OOB = 224,
  ENTITY_BLACK_MAW = 225,
  ENTITY_SKINNY = 226,
  ENTITY_BONY = 227,
  ENTITY_HOMUNCULUS = 228,
  ENTITY_TUMOR = 229,
  ENTITY_CAMILLO_JR = 230,
  ENTITY_NERVE_ENDING = 231,
  ENTITY_SKINBALL = 232,
  ENTITY_MOM_HEAD = 233,
  ENTITY_ONE_TOOTH = 234,
  ENTITY_GAPING_MAW = 235,
  ENTITY_BROKEN_GAPING_MAW = 236,
  ENTITY_GURGLING = 237,
  ENTITY_SPLASHER = 238,
  ENTITY_GRUB = 239,
  ENTITY_WALL_CREEP = 240,
  ENTITY_RAGE_CREEP = 241,
  ENTITY_BLIND_CREEP = 242,
  ENTITY_CONJOINED_SPITTY = 243,
  ENTITY_ROUND_WORM = 244,
  ENTITY_POOP = 245,
  ENTITY_RAGLING = 246,
  ENTITY_FLESH_MOBILE_HOST = 247,
  ENTITY_PSY_HORF = 248,
  ENTITY_FULL_FLY = 249,
  ENTITY_TICKING_SPIDER = 250,
  ENTITY_BEGOTTEN = 251,
  ENTITY_NULLS = 252,
  ENTITY_PSY_TUMOR = 253,
  ENTITY_FLOATING_KNIGHT = 254,
  ENTITY_NIGHT_CRAWLER = 255,
  ENTITY_DART_FLY = 256,
  ENTITY_CONJOINED_FATTY = 257,
  ENTITY_FAT_BAT = 258,
  ENTITY_IMP = 259,
  ENTITY_THE_HAUNT = 260,
  ENTITY_DINGLE = 261,
  ENTITY_MEGA_MAW = 262,
  ENTITY_GATE = 263,
  ENTITY_MEGA_FATTY = 264,
  ENTITY_CAGE = 265,
  ENTITY_MAMA_GURDY = 266,
  ENTITY_DARK_ONE = 267,
  ENTITY_ADVERSARY = 268,
  ENTITY_POLYCEPHALUS = 269,
  ENTITY_MR_FRED = 270,
  ENTITY_URIEL = 271,
  ENTITY_GABRIEL = 272,
  ENTITY_THE_LAMB = 273,
  ENTITY_MEGA_SATAN = 274,
  ENTITY_MEGA_SATAN_2 = 275,
  ENTITY_ROUNDY = 276,
  ENTITY_BLACK_BONY = 277,
  ENTITY_BLACK_GLOBIN = 278,
  ENTITY_BLACK_GLOBIN_HEAD = 279,
  ENTITY_BLACK_GLOBIN_BODY = 280,
  ENTITY_SWARM = 281,
  ENTITY_MEGA_CLOTTY = 282,
  ENTITY_BONE_KNIGHT = 283,
  ENTITY_CYCLOPIA = 284,
  ENTITY_RED_GHOST = 285,
  ENTITY_FLESH_DEATHS_HEAD = 286,
  ENTITY_MOMS_DEAD_HAND = 287,
  ENTITY_DUKIE = 288,
  ENTITY_ULCER = 289,
  ENTITY_MEATBALL = 290,
  ENTITY_PITFALL = 291,
  ENTITY_MOVABLE_TNT = 292,
  ENTITY_ULTRA_COIN = 293,
  ENTITY_ULTRA_DOOR = 294,
  ENTITY_CORN_MINE = 295,
  ENTITY_HUSH_FLY = 296,
  ENTITY_HUSH_GAPER = 297,
  ENTITY_HUSH_BOIL = 298,
  ENTITY_GREED_GAPER = 299,
  ENTITY_MUSHROOM = 300,
  ENTITY_POISON_MIND = 301,
  ENTITY_STONEY = 302,
  ENTITY_BLISTER = 303,
  ENTITY_THE_THING = 304,
  ENTITY_MINISTRO = 305,
  ENTITY_PORTAL = 306,
  ENTITY_TARBOY = 307,
  ENTITY_FISTULOID = 308,
  ENTITY_GUSH = 309,
  ENTITY_LEPER = 310,
  ENTITY_STAIN = 401,
  ENTITY_BROWNIE = 402,
  ENTITY_FORSAKEN = 403,
  ENTITY_LITTLE_HORN = 404,
  ENTITY_RAG_MAN = 405,
  ENTITY_ULTRA_GREED = 406,
  ENTITY_HUSH = 407,
  ENTITY_HUSH_SKINLESS = 408,
  ENTITY_RAG_MEGA = 409,
  ENTITY_SISTERS_VIS = 410,
  ENTITY_BIG_HORN = 411,
  ENTITY_DELIRIUM = 412,
  ENTITY_MATRIARCH = 413,
  ENTITY_BONE_WORM = 801,
  ENTITY_BLOOD_PUPPY = 802,
  ENTITY_QUAKE_GRIMACE = 804,
  ENTITY_BISHOP = 805,
  ENTITY_BUBBLES = 806,
  ENTITY_WRAITH = 807,
  ENTITY_WILLO = 808,
  ENTITY_BOMB_GRIMACE = 809,
  ENTITY_SMALL_LEECH = 810,
  ENTITY_DEEP_GAPER = 811,
  ENTITY_SUB_HORF = 812,
  ENTITY_BLURB = 813,
  ENTITY_STRIDER = 814,
  ENTITY_FISSURE = 815,
  ENTITY_POLTY = 816,
  ENTITY_PREY = 817,
  ENTITY_ROCK_SPIDER = 818,
  ENTITY_FLY_BOMB = 819,
  ENTITY_DANNY = 820,
  ENTITY_BLASTER = 821,
  ENTITY_BOUNCER = 822,
  ENTITY_QUAKEY = 823,
  ENTITY_GYRO = 824,
  ENTITY_FIRE_WORM = 825,
  ENTITY_HARDY = 826,
  ENTITY_FACELESS = 827,
  ENTITY_NECRO = 828,
  ENTITY_MOLE = 829,
  ENTITY_BIG_BONY = 830,
  ENTITY_GUTTED_FATTY = 831,
  ENTITY_EXORCIST = 832,
  ENTITY_CANDLER = 833,
  ENTITY_WHIPPER = 834,
  ENTITY_PEEPER_FATTY = 835,
  ENTITY_VIS_VERSA = 836,
  ENTITY_HENRY = 837,
  ENTITY_WILLO_L2 = 838,
  ENTITY_PON = 840,
  ENTITY_REVENANT = 841,
  ENTITY_BOMBGAGGER = 844,
  ENTITY_GAPER_L2 = 850,
  ENTITY_TWITCHY = 851,
  ENTITY_SPIKEBALL = 852,
  ENTITY_SMALL_MAGGOT = 853,
  ENTITY_ADULT_LEECH = 854,
  ENTITY_CHARGER_L2 = 855,
  ENTITY_GASBAG = 856,
  ENTITY_COHORT = 857,
  ENTITY_FLOATING_HOST = 859,
  ENTITY_UNBORN = 860,
  ENTITY_PUSTULE = 861,
  ENTITY_CYST = 862,
  ENTITY_MORNINGSTAR = 863,
  ENTITY_MOCKULUS = 864,
  ENTITY_EVIS = 865,
  ENTITY_DARK_ESAU = 866,
  ENTITY_MOTHERS_SHADOW = 867,
  ENTITY_ARMYFLY = 868,
  ENTITY_MIGRAINE = 869,
  ENTITY_DRIP = 870,
  ENTITY_SPLURT = 871,
  ENTITY_CLOGGY = 872,
  ENTITY_FLY_TRAP = 873,
  ENTITY_FARTIGAN = 874,
  ENTITY_POOT_MINE = 875,
  ENTITY_DUMP = 876,
  ENTITY_GRUDGE = 877,
  ENTITY_BUTT_SLICKER = 878,
  ENTITY_BLOATY = 879,
  ENTITY_FLESH_MAIDEN = 880,
  ENTITY_NEEDLE = 881,
  ENTITY_DUST = 882,
  ENTITY_BABY_BEGOTTEN = 883,
  ENTITY_SWARM_SPIDER = 884,
  ENTITY_CULTIST = 885,
  ENTITY_VIS_FATTY = 886,
  ENTITY_DUSTY_DEATHS_HEAD = 887,
  ENTITY_SHADY = 888,
  ENTITY_CLICKETY_CLACK = 889,
  ENTITY_MAZE_ROAMER = 890,
  ENTITY_GOAT = 891,
  ENTITY_POOFER = 892,
  ENTITY_BALL_AND_CHAIN = 893,
  ENTITY_REAP_CREEP = 900,
  ENTITY_LIL_BLUB = 901,
  ENTITY_RAINMAKER = 902,
  ENTITY_VISAGE = 903,
  ENTITY_SIREN = 904,
  ENTITY_HERETIC = 905,
  ENTITY_HORNFEL = 906,
  ENTITY_GIDEON = 907,
  ENTITY_BABY_PLUM = 908,
  ENTITY_SCOURGE = 909,
  ENTITY_CHIMERA = 910,
  ENTITY_ROTGUT = 911,
  ENTITY_MOTHER = 912,
  ENTITY_MIN_MIN = 913,
  ENTITY_CLOG = 914,
  ENTITY_SINGE = 915,
  ENTITY_BUMBINO = 916,
  ENTITY_COLOSTOMIA = 917,
  ENTITY_TURDLET = 918,
  ENTITY_RAGLICH = 919,
  ENTITY_HORNY_BOYS = 920,
  ENTITY_CLUTCH = 921,
  ENTITY_CADAVRA = 922,
  ENTITY_DOGMA = 950,
  ENTITY_BEAST = 951,
  ENTITY_GENERIC_PROP = 960,
  ENTITY_FROZEN_ENEMY = 963,
  ENTITY_DUMMY = 964,
  ENTITY_MINECART = 965,
  ENTITY_SIREN_HELPER = 966,
  ENTITY_HORNFEL_DOOR = 967,
  ENTITY_TRIGGER_OUTPUT = 969,
  ENTITY_ENVIRONMENT = 970,
  ENTITY_EFFECT = 1000,
  ENTITY_TEXT = 9001,
}

declare enum GridEntityType {
  GRID_NULL = 0,
  GRID_DECORATION = 1,
  GRID_ROCK = 2,
  /** A block. */
  GRID_ROCKB = 3,
  /** A tinted rock. */
  GRID_ROCKT = 4,
  GRID_ROCK_BOMB = 5,
  /** A pot, mushroom, or skull, depending on the stage and room type. */
  GRID_ROCK_ALT = 6,
  GRID_PIT = 7,
  GRID_SPIKES = 8,
  GRID_SPIKES_ONOFF = 9,
  GRID_SPIDERWEB = 10,
  GRID_LOCK = 11,
  GRID_TNT = 12,
  GRID_FIREPLACE = 13,
  GRID_POOP = 14,
  GRID_WALL = 15,
  GRID_DOOR = 16,
  GRID_TRAPDOOR = 17,
  GRID_STAIRS = 18,
  GRID_GRAVITY = 19,
  GRID_PRESSURE_PLATE = 20,
  GRID_STATUE = 21,
  /** A super tinted rock that yields double rewards. */
  GRID_ROCK_SS = 22,
  GRID_TELEPORTER = 23,
  GRID_PILLAR = 24,
  GRID_ROCK_SPIKED = 25,
  /** A tinted skull (that always drops a Fool card). */
  GRID_ROCK_ALT2 = 26,
  GRID_ROCK_GOLD = 27,
}

declare enum PickupPrice {
  PRICE_ONE_HEART = -1,
  PRICE_TWO_HEARTS = -2,
  PRICE_THREE_SOULHEARTS = -3,
  PRICE_ONE_HEART_AND_TWO_SOULHEARTS = -4,
  PRICE_SPIKES = -5,
  PRICE_SOUL = -6,
  PRICE_FREE = -1000,
}

declare enum Challenge {
  CHALLENGE_NULL = 0,
  CHALLENGE_PITCH_BLACK = 1,
  CHALLENGE_HIGH_BROW = 2,
  CHALLENGE_HEAD_TRAUMA = 3,
  CHALLENGE_DARKNESS_FALLS = 4,
  CHALLENGE_THE_TANK = 5,
  CHALLENGE_SOLAR_SYSTEM = 6,
  CHALLENGE_SUICIDE_KING = 7,
  CHALLENGE_CAT_GOT_YOUR_TONGUE = 8,
  CHALLENGE_DEMO_MAN = 9,
  CHALLENGE_CURSED = 10,
  CHALLENGE_GLASS_CANNON = 11,
  CHALLENGE_WHEN_LIFE_GIVES_LEMONS = 12,
  CHALLENGE_BEANS = 13,
  CHALLENGE_ITS_IN_THE_CARDS = 14,
  CHALLENGE_SLOW_ROLL = 15,
  CHALLENGE_COMPUTER_SAVY = 16,
  CHALLENGE_WAKA_WAKA = 17,
  CHALLENGE_THE_HOST = 18,
  CHALLENGE_THE_FAMILY_MAN = 19,
  CHALLENGE_PURIST = 20,
  CHALLENGE_XXXXXXXXL = 21,
  CHALLENGE_SPEED = 22,
  CHALLENGE_BLUE_BOMBER = 23,
  CHALLENGE_PAY_TO_PLAY = 24,
  CHALLENGE_HAVE_A_HEART = 25,
  CHALLENGE_I_RULE = 26,
  CHALLENGE_BRAINS = 27,
  CHALLENGE_PRIDE_DAY = 28,
  CHALLENGE_ONANS_STREAK = 29,
  CHALLENGE_GUARDIAN = 30,
  CHALLENGE_BACKASSWARDS = 31,
  CHALLENGE_APRILS_FOOL = 32,
  CHALLENGE_POKEY_MANS = 33,
  CHALLENGE_ULTRA_HARD = 34,
  CHALLENGE_PONG = 35,
  CHALLENGE_SCAT_MAN = 36,
  CHALLENGE_BLOODY_MARY = 37,
  CHALLENGE_BAPTISM_BY_FIRE = 38,
  CHALLENGE_ISAACS_AWAKENING = 39,
  CHALLENGE_SEEING_DOUBLE = 40,
  CHALLENGE_PICA_RUN = 41,
  CHALLENGE_HOT_POTATO = 42,
  CHALLENGE_CANTRIPPED = 43,
  CHALLENGE_RED_REDEMPTION = 44,
  CHALLENGE_DELETE_THIS = 45,
  NUM_CHALLENGES = 46,
}

declare enum NpcState {
  STATE_INIT = 0,
  STATE_APPEAR = 1,
  STATE_APPEAR_CUSTOM = 2,
  STATE_IDLE = 3,
  STATE_MOVE = 4,
  STATE_SUICIDE = 5,
  STATE_JUMP = 6,
  STATE_STOMP = 7,
  STATE_ATTACK = 8,
  STATE_ATTACK2 = 9,
  STATE_ATTACK3 = 10,
  STATE_ATTACK4 = 11,
  STATE_SUMMON = 12,
  STATE_SUMMON2 = 13,
  STATE_SUMMON3 = 14,
  STATE_SPECIAL = 15,
  STATE_UNIQUE_DEATH = 16,
  STATE_DEATH = 17,
}

declare enum EntityGridCollisionClass {
  GRIDCOLL_NONE = 0,
  GRIDCOLL_WALLS_X = 1,
  GRIDCOLL_WALLS_Y = 2,
  GRIDCOLL_WALLS = 3,
  GRIDCOLL_BULLET = 4,
  GRIDCOLL_GROUND = 5,
  GRIDCOLL_NOPITS = 6,
  GRIDCOLL_PITSONLY = 7,
}

declare enum EntityCollisionClass {
  ENTCOLL_NONE = 0,
  ENTCOLL_PLAYERONLY = 1,
  ENTCOLL_PLAYEROBJECTS = 2,
  ENTCOLL_ENEMIES = 3,
  ENTCOLL_ALL = 4,
}

declare enum SortingLayer {
  SORTING_BACKGROUND = 0,
  SORTING_DOOR = 1,
  SORTING_NORMAL = 2,
}

declare enum ItemType {
  ITEM_NULL = 0,
  ITEM_PASSIVE = 1,
  ITEM_TRINKET = 2,
  ITEM_ACTIVE = 3,
  ITEM_FAMILIAR = 4,
}

declare enum NullItemID {
  ID_NULL = -1,
  ID_EXPLOSIVE_DIARRHEA = 0,
  ID_PUBERTY = 1,
  ID_I_FOUND_PILLS = 2,
  ID_LORD_OF_THE_FLIES = 3,
  ID_STATUE = 4,
  ID_GUPPY = 5,
  ID_WIZARD = 6,
  ID_MAGDALENE = 7,
  ID_CAIN = 8,
  ID_JUDAS = 9,
  ID_EVE = 10,
  ID_AZAZEL = 11,
  ID_EDEN = 12,
  ID_SAMSON = 13,
  ID_BLINDFOLD = 14,
  ID_BLANKFACE = 15,
  ID_CHRISTMAS = 16,
  ID_PURITY_GLOW = 17,
  ID_EMPTY_VESSEL = 18,
  ID_MAW_MARK = 19,
  ID_MUSHROOM = 20,
  ID_ANGEL = 21,
  ID_BOB = 22,
  ID_DRUGS = 23,
  ID_MOM = 24,
  ID_BABY = 25,
  ID_EVIL_ANGEL = 26,
  ID_POOP = 27,
  ID_RELAX = 28,
  ID_OVERDOSE = 29,
  ID_BOOMERANG = 30,
  ID_MEGABLAST = 31,
  ID_LAZARUS = 32,
  ID_LAZARUS2 = 33,
  ID_LILITH = 34,
  ID_IWATA = 35,
  ID_APOLLYON = 36,
  ID_BOOKWORM = 37,
  ID_ADULTHOOD = 38,
  ID_SPIDERBABY = 39,
  ID_BATWING_WINGS = 40,
  ID_HUGE_GROWTH = 41,
  ID_ERA_WALK = 42,
  ID_SACRIFICIAL_ALTAR = 43,
  ID_FORGOTTEN = 44,
  ID_BRIMSTONE2 = 45,
  ID_HOLY_CARD = 46,
  ID_KEEPER = 47,
  ID_SPIN_TO_WIN = 50,
  ID_BETHANY = 51,
  ID_JACOB = 52,
  ID_ESAU = 53,
  ID_BLOOD_OATH = 54,
  ID_INTRUDER = 55,
  ID_SOL = 56,
  ID_IT_HURTS = 57,
  ID_MARS = 58,
  ID_TOOTH_AND_NAIL = 59,
  ID_REVERSE_MAGICIAN = 60,
  ID_REVERSE_HIGH_PRIESTESS = 61,
  ID_REVERSE_EMPRESS = 62,
  ID_REVERSE_CHARIOT = 63,
  ID_REVERSE_STRENGTH = 64,
  ID_REVERSE_HANGED_MAN = 65,
  ID_REVERSE_SUN = 66,
  ID_REVERSE_DEVIL = 67,
  ID_REVERSE_CHARIOT_ALT = 68,
  ID_REVERSE_TEMPERANCE = 69,
  ID_REVERSE_STARS = 70,
  ID_WAVY_CAP_1 = 71,
  ID_WAVY_CAP_2 = 72,
  ID_WAVY_CAP_3 = 73,
  ID_LUNA = 74,
  ID_JUPITER_BODY = 75,
  ID_JUPITER_BODY_ANGEL = 76,
  ID_JUPITER_BODY_PONY = 77,
  ID_JUPITER_BODY_WHITEPONY = 78,
  ID_ISAAC_B = 79,
  ID_MAGDALENE_B = 80,
  ID_CAIN_B = 81,
  ID_JUDAS_B = 82,
  ID_BLUEBABY_B = 83,
  ID_EVE_B = 84,
  ID_SAMSON_B = 85,
  ID_AZAZEL_B = 86,
  ID_LAZARUS_B = 87,
  ID_EDEN_B = 88,
  ID_LOST_B = 89,
  ID_LILITH_B = 90,
  ID_KEEPER_B = 91,
  ID_APOLLYON_B = 92,
  ID_FORGOTTEN_B = 93,
  ID_BETHANY_B = 94,
  ID_JACOB_B = 95,
  ID_AZAZELS_RAGE_1 = 96,
  ID_AZAZELS_RAGE_2 = 97,
  ID_AZAZELS_RAGE_3 = 98,
  ID_AZAZELS_RAGE_4 = 99,
  ID_ESAU_JR = 100,
  ID_SPIRIT_SHACKLES_SOUL = 101,
  ID_SPIRIT_SHACKLES_DISABLED = 102,
  ID_BERSERK_SAMSON = 103,
  ID_LAZARUS2_B = 104,
  ID_SOUL_B = 105,
  ID_FORGOTTEN_BOMB = 106,
  ID_EXTRA_BIG_FAN = 107,
  ID_JACOB2_B = 108,
  ID_JACOBS_CURSE = 109,
  ID_BLOODY_BABYLON = 110,
  ID_DARK_ARTS = 111,
  ID_LOST_CURSE = 112,
  ID_LAZARUS_SOUL_REVIVE = 113,
  ID_SOUL_MAGDALENE = 114,
  ID_SOUL_BLUEBABY = 115,
  ID_MIRROR_DEATH = 116,
  ID_HEMOPTYSIS = 117,
  ID_I_FOUND_HORSE_PILLS = 118,
  ID_HORSE_PUBERTY = 119,
  ID_SOUL_FORGOTTEN = 120,
  ID_SOUL_JACOB = 121,
  NUM_NULLITEMS = 122,
}

declare enum WeaponType {
  WEAPON_TEARS = 1,
  WEAPON_BRIMSTONE = 2,
  WEAPON_LASER = 3,
  WEAPON_KNIFE = 4,
  WEAPON_BOMBS = 5,
  WEAPON_ROCKETS = 6,
  WEAPON_MONSTROS_LUNGS = 7,
  WEAPON_LUDOVICO_TECHNIQUE = 8,
  WEAPON_TECH_X = 9,
  WEAPON_BONE = 10,
  WEAPON_NOTCHED_AXE = 11,
  WEAPON_URN_OF_SOULS = 12,
  WEAPON_SPIRIT_SWORD = 13,
  WEAPON_FETUS = 14,
  WEAPON_UMBILICAL_WHIP = 15,
  NUM_WEAPON_TYPES = 16,
}

declare enum PlayerSpriteLayer {
  SPRITE_GLOW = 0,
  SPRITE_BODY = 1,
  SPRITE_BODY0 = 2,
  SPRITE_BODY1 = 3,
  SPRITE_HEAD = 4,
  SPRITE_HEAD0 = 5,
  SPRITE_HEAD1 = 6,
  SPRITE_HEAD2 = 7,
  SPRITE_HEAD3 = 8,
  SPRITE_HEAD4 = 9,
  SPRITE_HEAD5 = 10,
  SPRITE_TOP0 = 11,
  SPRITE_EXTRA = 12,
  SPRITE_GHOST = 13,
  SPRITE_BACK = 14,
  NUM_SPRITE_LAYERS = 15,
}

declare enum LaserOffset {
  LASER_TECH1_OFFSET = 0,
  LASER_TECH2_OFFSET = 1,
  LASER_TECH5_OFFSET = 2,
  LASER_SHOOP_OFFSET = 3,
  LASER_BRIMSTONE_OFFSET = 4,
  LASER_MOMS_EYE_OFFSET = 5,
  LASER_TRACTOR_BEAM_OFFSET = 6,
}

declare enum ActionTriggers {
  ACTIONTRIGGER_NONE = 0,
  ACTIONTRIGGER_BOMBPLACED = 1,
  ACTIONTRIGGER_MOVED = 1 << 1,
  ACTIONTRIGGER_SHOOTING = 1 << 2,
  ACTIONTRIGGER_CARDPILLUSED = 1 << 3,
  ACTIONTRIGGER_ITEMACTIVATED = 1 << 4,
  ACTIONTRIGGER_ITEMSDROPPED = 1 << 5,
}

declare enum GridCollisionClass {
  COLLISION_NONE = 0,
  COLLISION_PIT = 1,
  COLLISION_OBJECT = 2,
  COLLISION_SOLID = 3,
  COLLISION_WALL = 4,
  COLLISION_WALL_EXCEPT_PLAYER = 5,
}

declare enum Direction {
  NO_DIRECTION = -1,
  LEFT = 0,
  UP = 1,
  RIGHT = 2,
  DOWN = 3,
}

declare enum LevelStage {
  STAGE_NULL = 0,
  STAGE1_1 = 1,
  STAGE1_2 = 2,
  STAGE2_1 = 3,
  STAGE2_2 = 4,
  STAGE3_1 = 5,
  STAGE3_2 = 6,
  STAGE4_1 = 7,
  STAGE4_2 = 8,
  STAGE4_3 = 9,
  STAGE5 = 10,
  STAGE6 = 11,
  STAGE7 = 12,
  STAGE8 = 13,
  NUM_STAGES = 14,
  STAGE1_GREED = 1,
  STAGE2_GREED = 2,
  STAGE3_GREED = 3,
  STAGE4_GREED = 4,
  STAGE5_GREED = 5,
  STAGE6_GREED = 6,
  STAGE7_GREED = 7,
  NUM_BACKWARDS_STAGES = 7,
}

declare enum StageType {
  STAGETYPE_ORIGINAL = 0,
  STAGETYPE_WOTL = 1,
  STAGETYPE_AFTERBIRTH = 2,
  STAGETYPE_GREEDMODE = 3,
  STAGETYPE_REPENTANCE = 4,
  STAGETYPE_REPENTANCE_B = 5,
}

declare enum RoomType {
  ROOM_NULL = 0,
  ROOM_DEFAULT = 1,
  ROOM_SHOP = 2,
  ROOM_ERROR = 3,
  ROOM_TREASURE = 4,
  ROOM_BOSS = 5,
  ROOM_MINIBOSS = 6,
  ROOM_SECRET = 7,
  ROOM_SUPERSECRET = 8,
  ROOM_ARCADE = 9,
  ROOM_CURSE = 10,
  ROOM_CHALLENGE = 11,
  ROOM_LIBRARY = 12,
  ROOM_SACRIFICE = 13,
  ROOM_DEVIL = 14,
  ROOM_ANGEL = 15,
  ROOM_DUNGEON = 16,
  ROOM_BOSSRUSH = 17,
  ROOM_ISAACS = 18,
  ROOM_BARREN = 19,
  ROOM_CHEST = 20,
  ROOM_DICE = 21,
  ROOM_BLACK_MARKET = 22,
  ROOM_GREED_EXIT = 23,
  ROOM_PLANETARIUM = 24,
  ROOM_TELEPORTER = 25,
  ROOM_TELEPORTER_EXIT = 26,
  ROOM_ULTRASECRET = 29,
  NUM_ROOMTYPES = 30,
}

declare enum RoomShape {
  ROOMSHAPE_1x1 = 1,
  ROOMSHAPE_IH = 2,
  ROOMSHAPE_IV = 3,
  ROOMSHAPE_1x2 = 4,
  ROOMSHAPE_IIV = 5,
  ROOMSHAPE_2x1 = 6,
  ROOMSHAPE_IIH = 7,
  ROOMSHAPE_2x2 = 8,
  ROOMSHAPE_LTL = 9,
  ROOMSHAPE_LTR = 10,
  ROOMSHAPE_LBL = 11,
  ROOMSHAPE_LBR = 12,
  NUM_ROOMSHAPES = 13,
}

declare enum DoorSlot {
  NO_DOOR_SLOT = -1,
  LEFT0 = 0,
  UP0 = 1,
  RIGHT0 = 2,
  DOWN0 = 3,
  LEFT1 = 4,
  UP1 = 5,
  RIGHT1 = 6,
  DOWN1 = 7,
  NUM_DOOR_SLOTS = 8,
}

declare enum LevelCurse {
  CURSE_NONE = 0,
  CURSE_OF_DARKNESS = 1,
  CURSE_OF_LABYRINTH = 1 << 1,
  CURSE_OF_THE_LOST = 1 << 2,
  CURSE_OF_THE_UNKNOWN = 1 << 3,
  CURSE_OF_THE_CURSED = 1 << 4,
  CURSE_OF_MAZE = 1 << 5,
  CURSE_OF_BLIND = 1 << 6,
  CURSE_OF_GIANT = 1 << 7,
  NUM_CURSES = 9,
}

declare enum PlayerForm {
  PLAYERFORM_GUPPY = 0,
  PLAYERFORM_LORD_OF_THE_FLIES = 1,
  PLAYERFORM_MUSHROOM = 2,
  PLAYERFORM_ANGEL = 3,
  PLAYERFORM_BOB = 4,
  PLAYERFORM_DRUGS = 5,
  PLAYERFORM_MOM = 6,
  PLAYERFORM_BABY = 7,
  PLAYERFORM_EVIL_ANGEL = 8,
  PLAYERFORM_POOP = 9,
  PLAYERFORM_BOOK_WORM = 10,
  PLAYERFORM_ADULTHOOD = 11,
  PLAYERFORM_SPIDERBABY = 12,
  PLAYERFORM_STOMPY = 13,
  /** This transformation is unused by the game. */
  PLAYERFORM_FLIGHT = 14,
  NUM_PLAYER_FORMS = 15,
}

declare enum PillColor {
  PILL_NULL = 0,
  PILL_BLUE_BLUE = 1,
  PILL_WHITE_BLUE = 2,
  PILL_ORANGE_ORANGE = 3,
  PILL_WHITE_WHITE = 4,
  PILL_REDDOTS_RED = 5,
  PILL_PINK_RED = 6,
  PILL_BLUE_CADETBLUE = 7,
  PILL_YELLOW_ORANGE = 8,
  PILL_ORANGEDOTS_WHITE = 9,
  PILL_WHITE_AZURE = 10,
  PILL_BLACK_YELLOW = 11,
  PILL_WHITE_BLACK = 12,
  PILL_WHITE_YELLOW = 13,
  NUM_STANDARD_PILLS = 14,
  PILL_GOLD = 14,
  NUM_PILLS = 15,
  PILL_GIANT_FLAG = 0x800,
  PILL_COLOR_MASK = 0x7ff,
}

declare enum Music {
  MUSIC_NULL = 0,
  MUSIC_BASEMENT = 1,
  MUSIC_CAVES = 2,
  MUSIC_DEPTHS = 3,
  MUSIC_CELLAR = 4,
  MUSIC_CATACOMBS = 5,
  MUSIC_NECROPOLIS = 6,
  MUSIC_WOMB_UTERO = 7,
  MUSIC_GAME_OVER = 8,
  MUSIC_BOSS = 9,
  MUSIC_CATHEDRAL = 10,
  MUSIC_SHEOL = 11,
  MUSIC_DARK_ROOM = 12,
  MUSIC_CHEST = 13,
  MUSIC_BURNING_BASEMENT = 14,
  MUSIC_FLOODED_CAVES = 15,
  MUSIC_DANK_DEPTHS = 16,
  MUSIC_SCARRED_WOMB = 17,
  MUSIC_BLUE_WOMB = 18,
  MUSIC_UTERO = 19,
  MUSIC_MOM_BOSS = 20,
  MUSIC_MOMS_HEART_BOSS = 21,
  MUSIC_ISAAC_BOSS = 22,
  MUSIC_SATAN_BOSS = 23,
  MUSIC_DARKROOM_BOSS = 24,
  MUSIC_BLUEBABY_BOSS = 25,
  MUSIC_BOSS2 = 26,
  MUSIC_HUSH_BOSS = 27,
  MUSIC_ULTRAGREED_BOSS = 28,
  MUSIC_LIBRARY_ROOM = 30,
  MUSIC_SECRET_ROOM = 31,
  MUSIC_SECRET_ROOM2 = 32,
  MUSIC_DEVIL_ROOM = 33,
  MUSIC_ANGEL_ROOM = 34,
  MUSIC_SHOP_ROOM = 35,
  MUSIC_ARCADE_ROOM = 36,
  MUSIC_BOSS_OVER = 37,
  MUSIC_CHALLENGE_FIGHT = 38,
  MUSIC_BOSS_RUSH = 39,
  MUSIC_JINGLE_BOSS_RUSH_OUTRO = 40,
  MUSIC_BOSS3 = 41,
  MUSIC_JINGLE_BOSS_OVER3 = 42,
  MUSIC_MOTHER_BOSS = 43,
  MUSIC_DOGMA_BOSS = 44,
  MUSIC_BEAST_BOSS = 45,
  MUSIC_JINGLE_MOTHER_OVER = 47,
  MUSIC_JINGLE_DOGMA_OVER = 48,
  MUSIC_JINGLE_BEAST_OVER = 49,
  MUSIC_PLANETARIUM = 50,
  MUSIC_SECRET_ROOM_ALT_ALT = 51,
  MUSIC_BOSS_OVER_TWISTED = 52,
  MUSIC_CREDITS = 60,
  MUSIC_TITLE = 61,
  MUSIC_TITLE_AFTERBIRTH = 62,
  MUSIC_TITLE_REPENTANCE = 63,
  MUSIC_JINGLE_GAME_START_ALT = 64,
  MUSIC_JINGLE_NIGHTMARE_ALT = 65,
  MUSIC_MOTHERS_SHADOW_INTRO = 66,
  MUSIC_DOGMA_INTRO = 67,
  MUSIC_STRANGE_DOOR_JINGLE = 68,
  MUSIC_DARK_CLOSET = 69,
  MUSIC_CREDITS_ALT = 70,
  MUSIC_CREDITS_ALT_FINAL = 71,
  MUSIC_JINGLE_BOSS = 81,
  MUSIC_JINGLE_BOSS_OVER = 83,
  MUSIC_JINGLE_HOLYROOM_FIND = 84,
  MUSIC_JINGLE_SECRETROOM_FIND = 85,
  MUSIC_JINGLE_TREASUREROOM_ENTRY_0 = 87,
  MUSIC_JINGLE_TREASUREROOM_ENTRY_1 = 88,
  MUSIC_JINGLE_TREASUREROOM_ENTRY_2 = 89,
  MUSIC_JINGLE_TREASUREROOM_ENTRY_3 = 90,
  MUSIC_JINGLE_CHALLENGE_ENTRY = 91,
  MUSIC_JINGLE_CHALLENGE_OUTRO = 92,
  MUSIC_JINGLE_GAME_OVER = 93,
  MUSIC_JINGLE_DEVILROOM_FIND = 94,
  MUSIC_JINGLE_GAME_START = 95,
  MUSIC_JINGLE_NIGHTMARE = 96,
  MUSIC_JINGLE_BOSS_OVER2 = 97,
  MUSIC_JINGLE_HUSH_OVER = 98,
  MUSIC_INTRO_VOICEOVER = 100,
  MUSIC_EPILOGUE_VOICEOVER = 101,
  MUSIC_VOID = 102,
  MUSIC_VOID_BOSS = 103,
  MUSIC_DOWNPOUR = 104,
  MUSIC_MINES = 105,
  MUSIC_MAUSOLEUM = 106,
  MUSIC_CORPSE = 107,
  MUSIC_DROSS = 108,
  MUSIC_ASHPIT = 109,
  MUSIC_GEHENNA = 110,
  MUSIC_MORTIS = 111,
  MUSIC_ISAACS_HOUSE = 112,
  MUSIC_FINAL_VOICEOVER = 113,
  MUSIC_DOWNPOUR_REVERSE = 114,
  MUSIC_DROSS_REVERSE = 115,
  MUSIC_MINESHAFT_AMBIENT = 116,
  MUSIC_MINESHAFT_ESCAPE = 117,
  MUSIC_REVERSE_GENESIS = 118,
  NUM_MUSIC = 119,
}

declare enum SoundEffect {
  SOUND_NULL = 0,
  SOUND_1UP = 1,
  SOUND_BIRD_FLAP = 2,
  SOUND_BLOBBY_WIGGLE = 3,
  SOUND_INSECT_SWARM_LOOP = 4,
  SOUND_BLOOD_LASER = 5,
  SOUND_BLOOD_LASER_SMALL = 6,
  SOUND_BLOOD_LASER_LARGE = 7,
  SOUND_BOOK_PAGE_TURN_12 = 8,
  SOUND_BOSS_BUG_HISS = 9,
  SOUND_BLOOD_LASER_LARGER = 10,
  SOUND_BOSS_GURGLE_ROAR = 11,
  SOUND_BOSS_LITE_GURGLE = 12,
  SOUND_BOSS_LITE_HISS = 13,
  SOUND_BOSS_LITE_ROAR = 14,
  SOUND_BOSS_LITE_SLOPPY_ROAR = 15,
  SOUND_BOSS_SPIT_BLOB_BARF = 16,
  SOUND_PAPER_IN = 17,
  SOUND_PAPER_OUT = 18,
  SOUND_CHEST_DROP = 21,
  SOUND_CHEST_OPEN = 22,
  SOUND_CHOIR_UNLOCK = 23,
  SOUND_COIN_SLOT = 24,
  SOUND_CUTE_GRUNT = 25,
  SOUND_DEATH_BURST_BONE = 27,
  SOUND_DEATH_BURST_LARGE = 28,
  SOUND_DEATH_REVERSE = 29,
  SOUND_DEATH_BURST_SMALL = 30,
  SOUND_DEATH_CARD = 33,
  SOUND_DEVIL_CARD = 34,
  SOUND_DOOR_HEAVY_CLOSE = 35,
  SOUND_DOOR_HEAVY_OPEN = 36,
  SOUND_FART = 37,
  SOUND_FETUS_JUMP = 38,
  SOUND_FETUS_LAND = 40,
  SOUND_FIREDEATH_HISS = 43,
  SOUND_FLOATY_BABY_ROAR = 44,
  SOUND_COIN_INSERT = 45,
  SOUND_METAL_DOOR_CLOSE = 46,
  SOUND_METAL_DOOR_OPEN = 47,
  SOUND_FORESTBOSS_STOMPS = 48,
  SOUND_SCYTHE_BREAK = 49,
  SOUND_STONE_WALKER = 50,
  SOUND_GASCAN_POUR = 51,
  SOUND_HELLBOSS_GROUNDPOUND = 52,
  SOUND_GLASS_BREAK = 53,
  SOUND_HOLY = 54,
  SOUND_ISAAC_HURT_GRUNT = 55,
  SOUND_CHILD_HAPPY_ROAR_SHORT = 56,
  SOUND_CHILD_ANGRY_ROAR = 57,
  SOUND_KEYPICKUP_GAUNTLET = 58,
  SOUND_KEY_DROP0 = 59,
  SOUND_BABY_HURT = 60,
  SOUND_MAGGOT_BURST_OUT = 64,
  SOUND_MAGGOT_ENTER_GROUND = 66,
  SOUND_MEAT_FEET_SLOW0 = 68,
  SOUND_MEAT_IMPACTS = 69,
  SOUND_MEAT_IMPACTS_OLD = 70,
  SOUND_MEAT_JUMPS = 72,
  SOUND_MEATY_DEATHS = 77,
  SOUND_POT_BREAK_2 = 78,
  SOUND_MUSHROOM_POOF_2 = 79,
  SOUND_BLACK_POOF = 80,
  SOUND_STATIC = 81,
  SOUND_MOM_VOX_DEATH = 82,
  SOUND_MOM_VOX_EVILLAUGH = 84,
  SOUND_MOM_VOX_FILTERED_DEATH_1 = 85,
  SOUND_MOM_VOX_FILTERED_EVILLAUGH = 86,
  SOUND_MOM_VOX_FILTERED_HURT = 87,
  SOUND_MOM_VOX_FILTERED_ISAAC = 90,
  SOUND_MOM_VOX_GRUNT = 93,
  SOUND_MOM_VOX_HURT = 97,
  SOUND_MOM_VOX_ISAAC = 101,
  SOUND_MONSTER_GRUNT_0 = 104,
  SOUND_MONSTER_GRUNT_1 = 106,
  SOUND_MONSTER_GRUNT_2 = 108,
  SOUND_MONSTER_GRUNT_4 = 112,
  SOUND_MONSTER_GRUNT_5 = 114,
  SOUND_MONSTER_ROAR_0 = 115,
  SOUND_MONSTER_ROAR_1 = 116,
  SOUND_MONSTER_ROAR_2 = 117,
  SOUND_MONSTER_ROAR_3 = 118,
  SOUND_MONSTER_YELL_A = 119,
  SOUND_MONSTER_YELL_B = 122,
  SOUND_POWERUP1 = 128,
  SOUND_POWERUP2 = 129,
  SOUND_POWERUP3 = 130,
  SOUND_POWERUP_SPEWER = 132,
  SOUND_REDLIGHTNING_ZAP = 133,
  SOUND_REDLIGHTNING_ZAP_WEAK = 134,
  SOUND_REDLIGHTNING_ZAP_STRONG = 135,
  SOUND_REDLIGHTNING_ZAP_BURST = 136,
  SOUND_ROCK_CRUMBLE = 137,
  SOUND_POT_BREAK = 138,
  SOUND_MUSHROOM_POOF = 139,
  SOUND_ROCKET_BLAST_DEATH = 141,
  SOUND_SMB_LARGE_CHEWS_4 = 142,
  SOUND_SCARED_WHIMPER = 143,
  SOUND_SHAKEY_KID_ROAR = 146,
  SOUND_SINK_DRAIN_GURGLE = 149,
  SOUND_TEARIMPACTS = 150,
  SOUND_TEARS_FIRE = 153,
  SOUND_UNLOCK00 = 156,
  SOUND_VAMP_GULP = 157,
  SOUND_WHEEZY_COUGH = 158,
  SOUND_SPIDER_COUGH = 159,
  SOUND_PORTAL_OPEN = 160,
  SOUND_PORTAL_LOOP = 161,
  SOUND_PORTAL_SPAWN = 162,
  SOUND_TAR_LOOP = 163,
  SOUND_ZOMBIE_WALKER_KID = 165,
  SOUND_ANIMAL_SQUISH = 166,
  SOUND_ANGRY_GURGLE = 167,
  SOUND_BAND_AID_PICK_UP = 169,
  SOUND_BATTERYCHARGE = 170,
  SOUND_BEEP = 171,
  SOUND_LIGHTBOLT = 172,
  SOUND_LIGHTBOLT_CHARGE = 173,
  SOUND_BLOODBANK_TOUCHED = 174,
  SOUND_BLOODBANK_SPAWN = 175,
  SOUND_BLOODSHOOT = 178,
  SOUND_BOIL_HATCH = 181,
  SOUND_BOSS1_EXPLOSIONS = 182,
  SOUND_EXPLOSION_WEAK = 183,
  SOUND_EXPLOSION_STRONG = 184,
  SOUND_BOSS2_BUBBLES = 185,
  SOUND_EXPLOSION_DEBRIS = 186,
  SOUND_BOSS2INTRO_ERRORBUZZ = 187,
  SOUND_CASTLEPORTCULLIS = 190,
  SOUND_CHARACTER_SELECT_LEFT = 194,
  SOUND_CHARACTER_SELECT_RIGHT = 195,
  SOUND_DERP = 197,
  SOUND_DIMEDROP = 198,
  SOUND_DIMEPICKUP = 199,
  SOUND_LUCKYPICKUP = 200,
  SOUND_FETUS_FEET = 201,
  SOUND_GOLDENKEY = 204,
  SOUND_GOOATTACH0 = 205,
  SOUND_GOODEATH = 207,
  SOUND_HAND_LASERS = 211,
  SOUND_HEARTIN = 212,
  SOUND_HEARTOUT = 213,
  SOUND_HELL_PORTAL1 = 214,
  SOUND_HELL_PORTAL2 = 215,
  SOUND_ISAACDIES = 217,
  SOUND_ITEMRECHARGE = 218,
  SOUND_KISS_LIPS1 = 219,
  SOUND_LEECH = 221,
  SOUND_MAGGOTCHARGE = 224,
  SOUND_MEATHEADSHOOT = 226,
  SOUND_METAL_BLOCKBREAK = 229,
  SOUND_NICKELDROP = 231,
  SOUND_NICKELPICKUP = 232,
  SOUND_PENNYDROP = 233,
  SOUND_PENNYPICKUP = 234,
  SOUND_PLOP = 237,
  SOUND_SATAN_APPEAR = 238,
  SOUND_SATAN_BLAST = 239,
  SOUND_SATAN_CHARGE_UP = 240,
  SOUND_SATAN_GROW = 241,
  SOUND_SATAN_HURT = 242,
  SOUND_SATAN_RISE_UP = 243,
  SOUND_SATAN_SPIT = 245,
  SOUND_SATAN_STOMP = 246,
  SOUND_SCAMPER = 249,
  SOUND_SHELLGAME = 252,
  SOUND_SLOTSPAWN = 255,
  SOUND_SPLATTER = 258,
  SOUND_STEAM_HALFSEC = 261,
  SOUND_STONESHOOT = 262,
  SOUND_WEIRD_WORM_SPIT = 263,
  SOUND_SUMMONSOUND = 265,
  SOUND_SUPERHOLY = 266,
  SOUND_THUMBS_DOWN = 267,
  SOUND_THUMBSUP = 268,
  SOUND_FIRE_BURN = 269,
  SOUND_HAPPY_RAINBOW = 270,
  SOUND_LASERRING = 271,
  SOUND_LASERRING_WEAK = 272,
  SOUND_LASERRING_STRONG = 273,
  SOUND_CASH_REGISTER = 274,
  SOUND_ANGEL_WING = 275,
  SOUND_ANGEL_BEAM = 276,
  SOUND_HOLY_MANTLE = 277,
  SOUND_MEGA_BLAST_START = 278,
  SOUND_MEGA_BLAST_LOOP = 279,
  SOUND_MEGA_BLAST_END = 280,
  SOUND_BLOOD_LASER_LOOP = 281,
  SOUND_MENU_SCROLL = 282,
  SOUND_MENU_NOTE_APPEAR = 283,
  SOUND_MENU_NOTE_HIDE = 284,
  SOUND_MENU_CHARACTER_SELECT = 285,
  SOUND_SUMMON_POOF = 286,
  SOUND_BOO_MAD = 300,
  SOUND_FART_GURG = 301,
  SOUND_FAT_GRUNT = 302,
  SOUND_FAT_WIGGLE = 303,
  SOUND_FIRE_RUSH = 304,
  SOUND_GHOST_ROAR = 305,
  SOUND_GHOST_SHOOT = 306,
  SOUND_GRROOWL = 307,
  SOUND_GURG_BARF = 308,
  SOUND_INHALE = 309,
  SOUND_LOW_INHALE = 310,
  SOUND_MEGA_PUKE = 311,
  SOUND_MOUTH_FULL = 312,
  SOUND_MULTI_SCREAM = 313,
  SOUND_SKIN_PULL = 314,
  SOUND_WHISTLE = 315,
  SOUND_DEVILROOM_DEAL = 316,
  SOUND_SPIDER_SPIT_ROAR = 317,
  SOUND_WORM_SPIT = 318,
  SOUND_LITTLE_SPIT = 319,
  SOUND_SATAN_ROOM_APPEAR = 320,
  SOUND_HEARTBEAT = 321,
  SOUND_HEARTBEAT_FASTER = 322,
  SOUND_HEARTBEAT_FASTEST = 323,
  SOUND_48_HR_ENERGY = 324,
  SOUND_ALGIZ = 325,
  SOUND_AMNESIA = 326,
  SOUND_ANZUS = 327,
  SOUND_BAD_GAS = 328,
  SOUND_BAD_TRIP = 329,
  SOUND_BALLS_OF_STEEL = 330,
  SOUND_BERKANO = 331,
  SOUND_BOMBS_ARE_KEY = 332,
  SOUND_CARD_VS_HUMAN = 333,
  SOUND_CHAOS_CARD = 334,
  SOUND_CREDIT_CARD = 335,
  SOUND_DAGAZ = 336,
  SOUND_DEATH = 337,
  SOUND_EHWAZ = 338,
  SOUND_EXPLOSIVE_DIAH = 339,
  SOUND_FULL_HP = 340,
  SOUND_HAGALAZ = 341,
  SOUND_HP_DOWN = 342,
  SOUND_HP_UP = 343,
  SOUND_HEMATEMISIS = 344,
  SOUND_I_FOUND_PILLS = 345,
  SOUND_JERA = 346,
  SOUND_JOKER = 347,
  SOUND_JUDGEMENT = 348,
  SOUND_JUSTICE = 349,
  SOUND_LEMON_PARTY = 350,
  SOUND_LUCK_DOWN = 351,
  SOUND_LUCK_UP = 352,
  SOUND_PARALYSIS = 353,
  SOUND_PERTHRO = 354,
  SOUND_PHEROMONES = 355,
  SOUND_PRETTY_FLY = 356,
  SOUND_PUBERTY = 357,
  SOUND_RUA_WIZ = 358,
  SOUND_RANGE_DOWN = 359,
  SOUND_RANGE_UP = 360,
  SOUND_RULES_CARD = 361,
  SOUND_SEE_4EVER = 362,
  SOUND_SPEED_DOWN = 363,
  SOUND_SPEED_UP = 364,
  SOUND_STRENGTH = 365,
  SOUND_SUICIDE_KING = 366,
  SOUND_TEARS_DOWN = 367,
  SOUND_TEARS_UP = 368,
  SOUND_TELEPILLS = 369,
  SOUND_TEMPERANCE = 370,
  SOUND_THE_CHARIOT = 371,
  SOUND_THE_DEVIL = 372,
  SOUND_THE_EMPEROR = 373,
  SOUND_EMPRESS = 374,
  SOUND_FOOL = 375,
  SOUND_HANGED_MAN = 376,
  SOUND_HERMIT = 377,
  SOUND_HIEROPHANT = 378,
  SOUND_HIGHT_PRIESTESS = 379,
  SOUND_THE_LOVERS = 380,
  SOUND_MAGICIAN = 381,
  SOUND_MOON = 382,
  SOUND_STARS = 383,
  SOUND_SUN = 384,
  SOUND_TOWER = 385,
  SOUND_WORLD = 386,
  SOUND_TWO_CLUBS = 387,
  SOUND_TWO_DIAMONDS = 388,
  SOUND_TWO_HEARTS = 389,
  SOUND_TWO_SPADES = 390,
  SOUND_WHEEL_OF_FORTUNE = 391,
  SOUND_RAGMAN_1 = 392,
  SOUND_RAGMAN_2 = 393,
  SOUND_RAGMAN_3 = 394,
  SOUND_RAGMAN_4 = 395,
  SOUND_FLUSH = 396,
  SOUND_WATER_DROP = 397,
  SOUND_WET_FEET = 398,
  SOUND_ADDICTED = 399,
  SOUND_DICE_SHARD = 400,
  SOUND_EMERGENCY = 401,
  SOUND_INFESTED_EXCL = 402,
  SOUND_INFESTED_QUEST = 403,
  SOUND_JAIL_CARD = 404,
  SOUND_LARGER = 405,
  SOUND_PERCS = 406,
  SOUND_POWER_PILL = 407,
  SOUND_QUESTION_MARK = 408,
  SOUND_RELAX = 409,
  SOUND_RETRO = 410,
  SOUND_SMALL = 411,
  SOUND_QQQ = 412,
  SOUND_DANGLE_WHISTLE = 413,
  SOUND_LITTLE_HORN_COUGH = 414,
  SOUND_LITTLE_HORN_GRUNT_1 = 415,
  SOUND_LITTLE_HORN_GRUNT_2 = 416,
  SOUND_THE_FORSAKEN_LAUGH = 417,
  SOUND_THE_FORSAKEN_SCREAM = 418,
  SOUND_THE_STAIN_BURST = 419,
  SOUND_BROWNIE_LAUGH = 420,
  SOUND_HUSH_ROAR = 421,
  SOUND_HUSH_GROWL = 422,
  SOUND_HUSH_LOW_ROAR = 423,
  SOUND_FRAIL_CHARGE = 424,
  SOUND_HUSH_CHARGE = 425,
  SOUND_MAW_OF_VOID = 426,
  SOUND_ULTRA_GREED_COIN_DESTROY = 427,
  SOUND_ULTRA_GREED_COINS_FALLING = 428,
  SOUND_ULTRA_GREED_DEATH_SCREAM = 429,
  SOUND_ULTRA_GREED_TURN_GOLD_1 = 430,
  SOUND_ULTRA_GREED_TURN_GOLD_2 = 431,
  SOUND_ULTRA_GREED_ROAR_1 = 432,
  SOUND_ULTRA_GREED_ROAR_2 = 433,
  SOUND_ULTRA_GREED_SPIT = 434,
  SOUND_ULTRA_GREED_PULL_SLOT = 435,
  SOUND_ULTRA_GREED_SLOT_SPIN_LOOP = 436,
  SOUND_ULTRA_GREED_SLOT_STOP = 437,
  SOUND_ULTRA_GREED_SLOT_WIN_LOOP_END = 438,
  SOUND_ULTRA_GREED_SLOT_WIN_LOOP = 439,
  SOUND_ULTRA_GREED_SPINNING = 440,
  SOUND_DOG_BARK = 441,
  SOUND_DOG_HOWELL = 442,
  SOUND_X_LAX = 443,
  SOUND_WRONG = 444,
  SOUND_VURP = 445,
  SOUND_SUNSHINE = 446,
  SOUND_SPADES = 447,
  SOUND_HORF = 448,
  SOUND_HOLY_CARD = 449,
  SOUND_HEARTS = 450,
  SOUND_GULP = 451,
  SOUND_FRIENDS = 452,
  SOUND_EXCITED = 453,
  SOUND_DROWSY = 454,
  SOUND_DIAMONDS = 455,
  SOUND_CLUBS = 456,
  SOUND_BLACK_RUNE = 457,
  SOUND_PING_PONG = 458,
  SOUND_SPEWER = 459,
  SOUND_MOM_FOOTSTEPS = 460,
  SOUND_BONE_HEART = 461,
  SOUND_BONE_SNAP = 462,
  SOUND_SHOVEL_DROP = 463,
  SOUND_SHOVEL_DIG = 464,
  SOUND_GOLD_HEART = 465,
  SOUND_GOLD_HEART_DROP = 466,
  SOUND_BONE_DROP = 467,
  SOUND_UNHOLY = 468,
  SOUND_BUTTON_PRESS = 469,
  SOUND_GOLDENBOMB = 470,
  SOUND_CANDLE_LIGHT = 471,
  SOUND_THUNDER = 472,
  SOUND_WATER_FLOW_LOOP = 473,
  SOUND_BOSS2_DIVE = 474,
  SOUND_BOSS2INTRO_PIPES_TURNON = 475,
  SOUND_WATER_FLOW_LARGE = 476,
  SOUND_DEMON_HIT = 477,
  SOUND_PUNCH = 478,
  SOUND_FLUTE = 479,
  SOUND_LAVA_LOOP = 480,
  SOUND_WOOD_PLANK_BREAK = 481,
  SOUND_BULLET_SHOT = 482,
  SOUND_FLAME_BURST = 483,
  SOUND_INFLATE = 484,
  SOUND_CLAP = 485,
  SOUND_BOSS2INTRO_WATER_EXPLOSION = 486,
  SOUND_STONE_IMPACT = 487,
  SOUND_BOSS2_WATERTHRASHING = 488,
  SOUND_FART_MEGA = 489,
  SOUND_MATCHSTICK = 490,
  SOUND_FORTUNE_COOKIE = 491,
  SOUND_BULB_FLASH = 492,
  SOUND_BATTERYDISCHARGE = 493,
  SOUND_WHIP = 494,
  SOUND_WHIP_HIT = 495,
  SOUND_FREEZE = 496,
  SOUND_ROTTEN_HEART = 497,
  SOUND_FREEZE_SHATTER = 498,
  SOUND_BONE_BOUNCE = 499,
  SOUND_BONE_BREAK = 500,
  SOUND_BISHOP_HIT = 501,
  SOUND_CHAIN_LOOP = 503,
  SOUND_CHAIN_BREAK = 504,
  SOUND_MINECART_LOOP = 505,
  SOUND_TOOTH_AND_NAIL = 506,
  SOUND_TOOTH_AND_NAIL_TICK = 507,
  SOUND_STATIC_BUILDUP = 508,
  SOUND_BIG_LEECH = 510,
  SOUND_REVERSE_EXPLOSION = 511,
  SOUND_REVERSE_FOOL = 512,
  SOUND_REVERSE_MAGICIAN = 513,
  SOUND_REVERSE_HIGH_PRIESTESS = 514,
  SOUND_REVERSE_EMPRESS = 515,
  SOUND_REVERSE_EMPEROR = 516,
  SOUND_REVERSE_HIEROPHANT = 517,
  SOUND_REVERSE_LOVERS = 518,
  SOUND_REVERSE_CHARIOT = 519,
  SOUND_REVERSE_JUSTICE = 520,
  SOUND_REVERSE_HERMIT = 521,
  SOUND_REVERSE_WHEEL_OF_FORTUNE = 522,
  SOUND_REVERSE_STRENGTH = 523,
  SOUND_REVERSE_HANGED_MAN = 524,
  SOUND_REVERSE_DEATH = 525,
  SOUND_REVERSE_TEMPERANCE = 526,
  SOUND_REVERSE_DEVIL = 527,
  SOUND_REVERSE_TOWER = 528,
  SOUND_REVERSE_STARS = 529,
  SOUND_REVERSE_MOON = 530,
  SOUND_REVERSE_SUN = 531,
  SOUND_REVERSE_JUDGEMENT = 532,
  SOUND_REVERSE_WORLD = 533,
  SOUND_FLAMETHROWER_START = 534,
  SOUND_FLAMETHROWER_LOOP = 535,
  SOUND_FLAMETHROWER_END = 536,
  SOUND_ROCKET_LAUNCH = 537,
  SOUND_SWORD_SPIN = 538,
  SOUND_BABY_BRIM = 539,
  SOUND_KNIFE_PULL = 540,
  SOUND_DOGMA_APPEAR_SCREAM = 541,
  SOUND_DOGMA_DEATH = 542,
  SOUND_DOGMA_BLACKHOLE_CHARGE = 543,
  SOUND_DOGMA_BLACKHOLE_SHOOT = 544,
  SOUND_DOGMA_BLACKHOLE_OPEN = 545,
  SOUND_DOGMA_BLACKHOLE_CLOSE = 546,
  SOUND_DOGMA_BRIMSTONE_CHARGE = 547,
  SOUND_DOGMA_BRIMSTONE_SHOOT = 548,
  SOUND_DOGMA_GODHEAD = 549,
  SOUND_DOGMA_JACOBS = 550,
  SOUND_DOGMA_JACOBS_ZAP = 551,
  SOUND_DOGMA_SCREAM = 552,
  SOUND_DOGMA_PREACHER = 553,
  SOUND_DOGMA_RING_START = 554,
  SOUND_DOGMA_RING_LOOP = 555,
  SOUND_DOGMA_FEATHER_SPRAY = 556,
  SOUND_DOGMA_JACOBS_DOT = 557,
  SOUND_DOGMA_BLACKHOLE_LOOP = 558,
  SOUND_DOGMA_ANGEL_TRANSFORM = 559,
  SOUND_DOGMA_ANGEL_TRANSFORM_END = 560,
  SOUND_DOGMA_LIGHT_APPEAR = 561,
  SOUND_DOGMA_LIGHT_BALL_THROW = 562,
  SOUND_DOGMA_LIGHT_RAY_CHARGE = 563,
  SOUND_DOGMA_LIGHT_RAY_FIRE = 564,
  SOUND_DOGMA_SPIN_ATTACK = 565,
  SOUND_DOGMA_WING_FLAP = 566,
  SOUND_DOGMA_TV_BREAK = 567,
  SOUND_DIVINE_INTERVENTION = 568,
  SOUND_MENU_FLIP_LIGHT = 569,
  SOUND_MENU_FLIP_DARK = 570,
  SOUND_MENU_RIP = 571,
  SOUND_URN_OPEN = 572,
  SOUND_URN_CLOSE = 573,
  SOUND_RECALL = 574,
  SOUND_LARYNX_SCREAM_LO = 575,
  SOUND_LARYNX_SCREAM_MED = 576,
  SOUND_LARYNX_SCREAM_HI = 577,
  SOUND_GROUND_TREMOR = 578,
  SOUND_SOUL_PICKUP = 579,
  SOUND_BALL_AND_CHAIN_LOOP = 580,
  SOUND_BALL_AND_CHAIN_HIT = 581,
  SOUND_LAZARUS_FLIP_DEAD = 582,
  SOUND_LAZARUS_FLIP_ALIVE = 583,
  SOUND_RECALL_FINISH = 584,
  SOUND_ROCKET_LAUNCH_SHORT = 585,
  SOUND_ROCKET_LAUNCH_TINY = 586,
  SOUND_ROCKET_EXPLOSION = 587,
  SOUND_JELLY_BOUNCE = 588,
  SOUND_POOP_LASER = 589,
  SOUND_POISON_WARN = 590,
  SOUND_POISON_HURT = 591,
  SOUND_BERSERK_START = 592,
  SOUND_BERSERK_TICK = 593,
  SOUND_BERSERK_END = 594,
  SOUND_EDEN_GLITCH = 595,
  SOUND_RAILROAD_TRACK_RAISE = 596,
  SOUND_RAILROAD_TRACK_RAISE_FAR = 597,
  SOUND_MOM_AND_DAD_1 = 598,
  SOUND_MOM_AND_DAD_2 = 599,
  SOUND_MOM_AND_DAD_3 = 600,
  SOUND_MOM_AND_DAD_4 = 601,
  SOUND_THUMBSUP_AMPLIFIED = 602,
  SOUND_THUMBSDOWN_AMPLIFIED = 603,
  SOUND_POWERUP_SPEWER_AMPLIFIED = 604,
  SOUND_POOPITEM_THROW = 605,
  SOUND_POOPITEM_STORE = 606,
  SOUND_POOPITEM_HOLD = 607,
  SOUND_MIRROR_ENTER = 608,
  SOUND_MIRROR_EXIT = 609,
  SOUND_MIRROR_BREAK = 610,
  SOUND_ANIMA_TRAP = 611,
  SOUND_ANIMA_RATTLE = 612,
  SOUND_ANIMA_BREAK = 613,
  SOUND_VAMP_DOUBLE = 614,
  SOUND_FLASHBACK = 615,
  SOUND_DARK_ESAU_OPEN = 616,
  SOUND_DARK_ESAU_DEATH_OPEN = 617,
  SOUND_MOTHER_DEATH1 = 618,
  SOUND_MOTHER_DEATH2 = 619,
  SOUND_MOTHER_FISTPOUND1 = 620,
  SOUND_MOTHER_FISTPOUND2 = 621,
  SOUND_MOTHER_FISTPOUND3 = 622,
  SOUND_MOTHER_FISTULA = 623,
  SOUND_MOTHER_APPEAR1 = 624,
  SOUND_MOTHER_APPEAR2 = 625,
  SOUND_MOTHER_KNIFE_START = 626,
  SOUND_MOTHER_KNIFE_THROW = 627,
  SOUND_MOTHER_SUMMON_ISAACS_START = 628,
  SOUND_MOTHER_SUMMON_ISAACS_END = 629,
  SOUND_MOTHER_HAND_BOIL_START = 630,
  SOUND_MOTHER_GRUNT1 = 631,
  SOUND_MOTHER_GRUNT5 = 632,
  SOUND_MOTHER_GRUNT6 = 633,
  SOUND_MOTHER_GRUNT7 = 634,
  SOUND_MOTHER_LAUGH = 635,
  SOUND_MOTHER_SPIN_START = 636,
  SOUND_MOTHER_WALL_SHOT_START = 637,
  SOUND_MOTHER_MISC = 638,
  SOUND_MOTHER_SHOOT = 639,
  SOUND_MOTHER_SUCTION = 640,
  SOUND_MOTHER_ISAAC_RISE = 641,
  SOUND_MOTHER_ISAAC_HIT = 642,
  SOUND_MOTHER_WRIST_SWELL = 643,
  SOUND_MOTHER_WRIST_EXPLODE = 644,
  SOUND_MOTHER_DEATH_MELT = 645,
  SOUND_MOTHER_ANGER_SHAKE = 646,
  SOUND_MOTHER_CHARGE1 = 647,
  SOUND_MOTHER_CHARGE2 = 648,
  SOUND_MOTHER_LAND_SMASH = 649,
  SOUND_ISAAC_ROAR = 650,
  SOUND_FAMINE_APPEAR = 651,
  SOUND_FAMINE_DEATH_1 = 652,
  SOUND_FAMINE_DEATH_2 = 653,
  SOUND_FAMINE_DASH_START = 654,
  SOUND_FAMINE_DASH = 655,
  SOUND_FAMINE_SHOOT = 656,
  SOUND_FAMINE_BURST = 657,
  SOUND_FAMINE_GURGLE = 658,
  SOUND_PESTILENCE_MAGGOT_START = 659,
  SOUND_PESTILENCE_MAGGOT_SHOOT = 660,
  SOUND_PESTILENCE_MAGGOT_RETURN = 661,
  SOUND_PESTILENCE_BODY_SHOOT = 662,
  SOUND_PESTILENCE_HEAD_DEATH = 663,
  SOUND_PESTILENCE_DEATH = 664,
  SOUND_PESTILENCE_COUGH = 665,
  SOUND_PESTILENCE_BARF = 666,
  SOUND_PESTILENCE_APPEAR = 667,
  SOUND_PESTILENCE_HEAD_EXPLODE = 668,
  SOUND_PESTILENCE_MAGGOT_ENTER = 669,
  SOUND_PESTILENCE_MAGGOT_POPOUT = 670,
  SOUND_PESTILENCE_MAGGOT_SHOOT2 = 671,
  SOUND_PESTILENCE_NECK_PUKE = 672,
  SOUND_PESTILENCE_PUKE_START = 673,
  SOUND_WAR_APPEAR = 674,
  SOUND_WAR_APPEAR_LAVA = 675,
  SOUND_WAR_BOMB_TOSS = 676,
  SOUND_WAR_DASH_START = 677,
  SOUND_WAR_DASH = 678,
  SOUND_WAR_HORSE_DEATH = 679,
  SOUND_WAR_DEATH = 680,
  SOUND_WAR_FIRE_SCREEM = 681,
  SOUND_WAR_GRAB_PLAYER = 682,
  SOUND_WAR_BOMB_HOLD = 683,
  SOUND_WAR_BOMB_PULL_OUT = 684,
  SOUND_WAR_CHASE = 685,
  SOUND_WAR_BOMB_TICK = 686,
  SOUND_WAR_FLAME = 687,
  SOUND_WAR_LAVA_SPLASH = 688,
  SOUND_WAR_LAVA_DASH = 689,
  SOUND_DEATH_DIES = 690,
  SOUND_DEATH_DESTROY_SKULLS = 691,
  SOUND_DEATH_GROWL = 692,
  SOUND_DEATH_SWIPE_START = 693,
  SOUND_DEATH_SWIPE = 694,
  SOUND_DEATH_SUMMON_SCYTHES = 695,
  SOUND_DEATH_SUMMON_SKULLS = 696,
  SOUND_BEAST_DEATH = 697,
  SOUND_BEAST_LASER = 698,
  SOUND_BEAST_BACKGROUND_DIVE = 699,
  SOUND_BEAST_FIRE_RING = 700,
  SOUND_BEAST_GHOST_DASH = 701,
  SOUND_BEAST_GHOST_RISE = 702,
  SOUND_BEAST_LAVA_BALL_SPLASH = 703,
  SOUND_BEAST_LAVA_RISE = 704,
  SOUND_BEAST_SUCTION_LOOP = 705,
  SOUND_BEAST_FIRE_BARF = 706,
  SOUND_BEAST_GHOST_ROAR = 707,
  SOUND_BEAST_INTRO_SCREAM = 708,
  SOUND_BEAST_SUCTION_END = 709,
  SOUND_BEAST_SUCTION_START = 710,
  SOUND_BEAST_SPIT = 711,
  SOUND_BEAST_SURFACE_GROWL = 712,
  SOUND_BEAST_SWITCH_SIDES = 713,
  SOUND_MOTHERSHADOW_APPEAR = 714,
  SOUND_MOTHERSHADOW_CHARGE_UP = 715,
  SOUND_MOTHERSHADOW_DASH = 716,
  SOUND_MOTHERSHADOW_END = 717,
  SOUND_MOTHERSHADOW_INTRO = 718,
  SOUND_BUMBINO_DEATH = 719,
  SOUND_BUMBINO_DIZZY = 720,
  SOUND_BUMBINO_HIT_WALL = 721,
  SOUND_BUMBINO_MISC = 722,
  SOUND_BUMBINO_PUNCH = 723,
  SOUND_BUMBINO_RAM = 724,
  SOUND_BUMBINO_SLAM = 725,
  SOUND_BUMBINO_SNAP_OUT = 726,
  SOUND_SIREN_SCREAM = 727,
  SOUND_SIREN_SING = 728,
  SOUND_DEATH_SKULL_SUMMON_LOOP = 729,
  SOUND_DEATH_SKULL_SUMMON_END = 730,
  SOUND_BEAST_DEATH_2 = 731,
  SOUND_BEAST_ANGELIC_BLAST = 732,
  SOUND_ANCIENT_RECALL = 733,
  SOUND_ERA_WALK = 734,
  SOUND_HUGE_GROWTH = 735,
  SOUND_RUNE_SHARD = 736,
  SOUND_SHOT_SPEED_DOWN = 737,
  SOUND_SHOT_SPEED_UP = 738,
  SOUND_EXPERIMENTAL_PILL = 739,
  SOUND_CRACKED_KEY = 740,
  SOUND_QUEEN_OF_HEARTS = 741,
  SOUND_WILD_CARD = 742,
  SOUND_SOUL_OF_ISAAC = 743,
  SOUND_SOUL_OF_MAGDALENE = 744,
  SOUND_SOUL_OF_CAIN = 745,
  SOUND_SOUL_OF_JUDAS = 746,
  SOUND_SOUL_OF_XXX = 747,
  SOUND_SOUL_OF_EVE = 748,
  SOUND_SOUL_OF_SAMSON = 749,
  SOUND_SOUL_OF_AZAZEL = 750,
  SOUND_SOUL_OF_LAZARUS = 751,
  SOUND_SOUL_OF_EDEN = 752,
  SOUND_SOUL_OF_THE_LOST = 753,
  SOUND_SOUL_OF_LILITH = 754,
  SOUND_SOUL_OF_THE_KEEPER = 755,
  SOUND_SOUL_OF_APOLLYON = 756,
  SOUND_SOUL_OF_THE_FORGOTTEN = 757,
  SOUND_SOUL_OF_BETHANY = 758,
  SOUND_SOUL_OF_JACOB_AND_ESAU = 759,
  SOUND_MEGA_BAD_GAS = 760,
  SOUND_MEGA_BAD_TRIP = 761,
  SOUND_MEGA_BALLS_OF_STEEL = 762,
  SOUND_MEGA_BOMBS_ARE_KEY = 763,
  SOUND_MEGA_EXPLOSIVE_DIARRHEA = 764,
  SOUND_MEGA_FULL_HEALTH = 765,
  SOUND_MEGA_HEALTH_UP = 766,
  SOUND_MEGA_HEALTH_DOWN = 767,
  SOUND_MEGA_I_FOUND_PILLS = 768,
  SOUND_MEGA_PUBERTY = 769,
  SOUND_MEGA_PRETTY_FLY = 770,
  SOUND_MEGA_RANGE_DOWN = 771,
  SOUND_MEGA_RANGE_UP = 772,
  SOUND_MEGA_SPEED_DOWN = 773,
  SOUND_MEGA_SPEED_UP = 774,
  SOUND_MEGA_TEARS_DOWN = 775,
  SOUND_MEGA_TEARS_UP = 776,
  SOUND_MEGA_LUCK_DOWN = 777,
  SOUND_MEGA_LUCK_UP = 778,
  SOUND_MEGA_TELEPILLS = 779,
  SOUND_MEGA_48_HR_ENERGY = 780,
  SOUND_MEGA_HEMATEMESIS = 781,
  SOUND_MEGA_PARALYSIS = 782,
  SOUND_MEGA_I_CAN_SEE_FOREVER = 783,
  SOUND_MEGA_PHEROMONES = 784,
  SOUND_MEGA_AMNESIA = 785,
  SOUND_MEGA_LEMON_PARTY = 786,
  SOUND_MEGA_ARE_YOU_A_WIZARD = 787,
  SOUND_MEGA_PERCS = 788,
  SOUND_MEGA_ADDICTED = 789,
  SOUND_MEGA_RELAX = 790,
  SOUND_MEGA_TRIPLE_QUESTION_MARK = 791,
  SOUND_MEGA_ONE_MAKES_YOU_LARGER = 792,
  SOUND_MEGA_ONE_MAKES_YOU_SMALL = 793,
  SOUND_MEGA_INFESTED = 794,
  SOUND_MEGA_INFESTED_1 = 795,
  SOUND_MEGA_POWER_PILL = 796,
  SOUND_MEGA_RETRO_VISION = 797,
  SOUND_MEGA_FRIENDS_TIL_THE_END = 798,
  SOUND_MEGA_EXLAX = 799,
  SOUND_MEGA_SOMETHINGS_WRONG = 800,
  SOUND_MEGA_IM_DROWSY = 801,
  SOUND_MEGA_IM_EXCITED = 802,
  SOUND_MEGA_GULP = 803,
  SOUND_MEGA_HORF = 804,
  SOUND_MEGA_SUNSHINE = 805,
  SOUND_MEGA_VURP = 806,
  SOUND_MEGA_SHOT_SPEED_DOWN = 807,
  SOUND_MEGA_SHOT_SPEED_UP = 808,
  SOUND_MEGA_EXPERIMENTAL_PILL = 809,
  SOUND_SIREN_LUNGE = 810,
  SOUND_SIREN_MINION_SMOKE = 811,
  SOUND_SIREN_SCREAM_ATTACK = 812,
  SOUND_SIREN_SING_STAB = 813,
  SOUND_BEAST_LAVABALL_RISE = 814,
  SOUND_BEAST_GROWL = 815,
  SOUND_BEAST_GRUMBLE = 816,
  NUM_SOUND_EFFECTS = 817,
}

declare enum DoorState {
  STATE_INIT = 0,
  STATE_CLOSED = 1,
  STATE_OPEN = 2,
  STATE_ONE_CHAIN = 3,
  STATE_HALF_CRACKED = 4,
}

declare enum Difficulty {
  DIFFICULTY_NORMAL = 0,
  DIFFICULTY_HARD = 1,
  DIFFICULTY_GREED = 2,
  DIFFICULTY_GREEDIER = 3,
}

declare enum PillEffect {
  PILLEFFECT_NULL = -1,
  PILLEFFECT_BAD_GAS = 0,
  PILLEFFECT_BAD_TRIP = 1,
  PILLEFFECT_BALLS_OF_STEEL = 2,
  PILLEFFECT_BOMBS_ARE_KEYS = 3,
  PILLEFFECT_EXPLOSIVE_DIARRHEA = 4,
  PILLEFFECT_FULL_HEALTH = 5,
  PILLEFFECT_HEALTH_DOWN = 6,
  PILLEFFECT_HEALTH_UP = 7,
  PILLEFFECT_I_FOUND_PILLS = 8,
  PILLEFFECT_PUBERTY = 9,
  PILLEFFECT_PRETTY_FLY = 10,
  PILLEFFECT_RANGE_DOWN = 11,
  PILLEFFECT_RANGE_UP = 12,
  PILLEFFECT_SPEED_DOWN = 13,
  PILLEFFECT_SPEED_UP = 14,
  PILLEFFECT_TEARS_DOWN = 15,
  PILLEFFECT_TEARS_UP = 16,
  PILLEFFECT_LUCK_DOWN = 17,
  PILLEFFECT_LUCK_UP = 18,
  PILLEFFECT_TELEPILLS = 19,
  PILLEFFECT_48HOUR_ENERGY = 20,
  PILLEFFECT_HEMATEMESIS = 21,
  PILLEFFECT_PARALYSIS = 22,
  PILLEFFECT_SEE_FOREVER = 23,
  PILLEFFECT_PHEROMONES = 24,
  PILLEFFECT_AMNESIA = 25,
  PILLEFFECT_LEMON_PARTY = 26,
  PILLEFFECT_WIZARD = 27,
  PILLEFFECT_PERCS = 28,
  PILLEFFECT_ADDICTED = 29,
  PILLEFFECT_RELAX = 30,
  PILLEFFECT_QUESTIONMARK = 31,
  PILLEFFECT_LARGER = 32,
  PILLEFFECT_SMALLER = 33,
  PILLEFFECT_INFESTED_EXCLAMATION = 34,
  PILLEFFECT_INFESTED_QUESTION = 35,
  PILLEFFECT_POWER = 36,
  PILLEFFECT_RETRO_VISION = 37,
  PILLEFFECT_FRIENDS_TILL_THE_END = 38,
  PILLEFFECT_X_LAX = 39,
  PILLEFFECT_SOMETHINGS_WRONG = 40,
  PILLEFFECT_IM_DROWSY = 41,
  PILLEFFECT_IM_EXCITED = 42,
  PILLEFFECT_GULP = 43,
  PILLEFFECT_HORF = 44,
  PILLEFFECT_SUNSHINE = 45,
  PILLEFFECT_VURP = 46,
  PILLEFFECT_SHOT_SPEED_DOWN = 47,
  PILLEFFECT_SHOT_SPEED_UP = 48,
  PILLEFFECT_EXPERIMENTAL = 49,
  NUM_PILL_EFFECTS = 50,
}

declare enum ButtonAction {
  ACTION_LEFT = 0,
  ACTION_RIGHT = 1,
  ACTION_UP = 2,
  ACTION_DOWN = 3,
  ACTION_SHOOTLEFT = 4,
  ACTION_SHOOTRIGHT = 5,
  ACTION_SHOOTUP = 6,
  ACTION_SHOOTDOWN = 7,
  ACTION_BOMB = 8,
  ACTION_ITEM = 9,
  ACTION_PILLCARD = 10,
  ACTION_DROP = 11,
  ACTION_PAUSE = 12,
  ACTION_MAP = 13,
  ACTION_MENUCONFIRM = 14,
  ACTION_MENUBACK = 15,
  ACTION_RESTART = 16,
  ACTION_FULLSCREEN = 17,
  ACTION_MUTE = 18,
  ACTION_JOINMULTIPLAYER = 19,
  ACTION_MENULEFT = 20,
  ACTION_MENURIGHT = 21,
  ACTION_MENUUP = 22,
  ACTION_MENUDOWN = 23,
  ACTION_MENULT = 24,
  ACTION_MENURT = 25,
  ACTION_MENUTAB = 26,
  ACTION_CONSOLE = 28,
}

declare enum Keyboard {
  KEY_SPACE = 32,
  KEY_APOSTROPHE = 39,
  KEY_COMMA = 44,
  KEY_MINUS = 45,
  KEY_PERIOD = 46,
  KEY_SLASH = 47,
  KEY_0 = 48,
  KEY_1 = 49,
  KEY_2 = 50,
  KEY_3 = 51,
  KEY_4 = 52,
  KEY_5 = 53,
  KEY_6 = 54,
  KEY_7 = 55,
  KEY_8 = 56,
  KEY_9 = 57,
  KEY_SEMICOLON = 59,
  KEY_EQUAL = 61,
  KEY_A = 65,
  KEY_B = 66,
  KEY_C = 67,
  KEY_D = 68,
  KEY_E = 69,
  KEY_F = 70,
  KEY_G = 71,
  KEY_H = 72,
  KEY_I = 73,
  KEY_J = 74,
  KEY_K = 75,
  KEY_L = 76,
  KEY_M = 77,
  KEY_N = 78,
  KEY_O = 79,
  KEY_P = 80,
  KEY_Q = 81,
  KEY_R = 82,
  KEY_S = 83,
  KEY_T = 84,
  KEY_U = 85,
  KEY_V = 86,
  KEY_W = 87,
  KEY_X = 88,
  KEY_Y = 89,
  KEY_Z = 90,
  KEY_LEFT_BRACKET = 91,
  KEY_BACKSLASH = 92,
  KEY_RIGHT_BRACKET = 93,
  KEY_GRAVE_ACCENT = 96,
  KEY_WORLD_1 = 161,
  KEY_WORLD_2 = 162,
  KEY_ESCAPE = 256,
  KEY_ENTER = 257,
  KEY_TAB = 258,
  KEY_BACKSPACE = 259,
  KEY_INSERT = 260,
  KEY_DELETE = 261,
  KEY_RIGHT = 262,
  KEY_LEFT = 263,
  KEY_DOWN = 264,
  KEY_UP = 265,
  KEY_PAGE_UP = 266,
  KEY_PAGE_DOWN = 267,
  KEY_HOME = 268,
  KEY_END = 269,
  KEY_CAPS_LOCK = 280,
  KEY_SCROLL_LOCK = 281,
  KEY_NUM_LOCK = 282,
  KEY_PRINT_SCREEN = 283,
  KEY_PAUSE = 284,
  KEY_F1 = 290,
  KEY_F2 = 291,
  KEY_F3 = 292,
  KEY_F4 = 293,
  KEY_F5 = 294,
  KEY_F6 = 295,
  KEY_F7 = 296,
  KEY_F8 = 297,
  KEY_F9 = 298,
  KEY_F10 = 299,
  KEY_F11 = 300,
  KEY_F12 = 301,
  KEY_F13 = 302,
  KEY_F14 = 303,
  KEY_F15 = 304,
  KEY_F16 = 305,
  KEY_F17 = 306,
  KEY_F18 = 307,
  KEY_F19 = 308,
  KEY_F20 = 309,
  KEY_F21 = 310,
  KEY_F22 = 311,
  KEY_F23 = 312,
  KEY_F24 = 313,
  KEY_F25 = 314,
  KEY_KP_0 = 320,
  KEY_KP_1 = 321,
  KEY_KP_2 = 322,
  KEY_KP_3 = 323,
  KEY_KP_4 = 324,
  KEY_KP_5 = 325,
  KEY_KP_6 = 326,
  KEY_KP_7 = 327,
  KEY_KP_8 = 328,
  KEY_KP_9 = 329,
  KEY_KP_DECIMAL = 330,
  KEY_KP_DIVIDE = 331,
  KEY_KP_MULTIPLY = 332,
  KEY_KP_SUBTRACT = 333,
  KEY_KP_ADD = 334,
  KEY_KP_ENTER = 335,
  KEY_KP_EQUAL = 336,
  KEY_LEFT_SHIFT = 340,
  KEY_LEFT_CONTROL = 341,
  KEY_LEFT_ALT = 342,
  KEY_LEFT_SUPER = 343,
  KEY_RIGHT_SHIFT = 344,
  KEY_RIGHT_CONTROL = 345,
  KEY_RIGHT_ALT = 346,
  KEY_RIGHT_SUPER = 347,
  KEY_MENU = 348,
}

declare enum Mouse {
  MOUSE_BUTTON_1 = 0,
  MOUSE_BUTTON_2 = 1,
  MOUSE_BUTTON_3 = 2,
  MOUSE_BUTTON_4 = 3,
  MOUSE_BUTTON_5 = 4,
  MOUSE_BUTTON_6 = 5,
  MOUSE_BUTTON_7 = 6,
  MOUSE_BUTTON_8 = 7,
  MOUSE_BUTTON_LAST = 7,
  MOUSE_BUTTON_LEFT = 0,
  MOUSE_BUTTON_RIGHT = 1,
  MOUSE_BUTTON_MIDDLE = 2,
}

declare enum InputHook {
  IS_ACTION_PRESSED = 0,
  IS_ACTION_TRIGGERED = 1,
  GET_ACTION_VALUE = 2,
}

declare enum SeedEffect {
  SEED_NORMAL = 0,
  SEED_MOVEMENT_PITCH = 1,
  SEED_HEALTH_PITCH = 2,
  SEED_CAMO_ISAAC = 3,
  SEED_CAMO_ENEMIES = 4,
  SEED_CAMO_PICKUPS = 5,
  SEED_CAMO_EVERYTHING = 6,
  SEED_FART_SOUNDS = 7,
  SEED_OLD_TV = 8,
  SEED_DYSLEXIA = 9,
  SEED_NO_HUD = 10,
  SEED_PICKUPS_SLIDE = 11,
  SEED_CONTROLS_REVERSED = 12,
  SEED_ALL_CHAMPIONS = 13,
  SEED_INVISIBLE_ISAAC = 14,
  SEED_INVISIBLE_ENEMIES = 15,
  SEED_INFINITE_BASEMENT = 16,
  SEED_ALWAYS_CHARMED = 17,
  SEED_ALWAYS_CONFUSED = 18,
  SEED_ALWAYS_AFRAID = 19,
  SEED_ALWAYS_ALTERNATING_FEAR = 20,
  SEED_ALWAYS_CHARMED_AND_AFRAID = 21,
  SEED_EXTRA_BLOOD = 23,
  SEED_POOP_TRAIL = 24,
  SEED_PACIFIST = 25,
  SEED_DAMAGE_WHEN_STOPPED = 26,
  SEED_DAMAGE_ON_INTERVAL = 27,
  SEED_DAMAGE_ON_TIME_LIMIT = 28,
  SEED_PILLS_NEVER_IDENTIFY = 29,
  SEED_MYSTERY_TAROT_CARDS = 30,
  SEED_ENEMIES_RESPAWN = 32,
  SEED_ITEMS_COST_MONEY = 33,
  SEED_BIG_HEAD = 35,
  SEED_SMALL_HEAD = 36,
  SEED_BLACK_ISAAC = 37,
  SEED_GLOWING_TEARS = 38,
  SEED_SLOW_MUSIC = 41,
  SEED_ULTRA_SLOW_MUSIC = 42,
  SEED_FAST_MUSIC = 43,
  SEED_ULTRA_FAST_MUSIC = 44,
  SEED_NO_FACE = 46,
  SEED_ISAAC_TAKES_HIGH_DAMAGE = 47,
  SEED_ISAAC_TAKES_MASSIVE_DAMAGE = 48,
  SEED_ICE_PHYSICS = 52,
  SEED_KAPPA = 53,
  SEED_CHRISTMAS = 54,
  SEED_KIDS_MODE = 55,
  SEED_PERMANENT_CURSE_DARKNESS = 56,
  SEED_PERMANENT_CURSE_LABYRINTH = 57,
  SEED_PERMANENT_CURSE_LOST = 58,
  SEED_PERMANENT_CURSE_UNKNOWN = 59,
  SEED_PERMANENT_CURSE_MAZE = 60,
  SEED_PERMANENT_CURSE_BLIND = 61,
  SEED_PERMANENT_CURSE_CURSED = 62,
  SEED_PREVENT_CURSE_DARKNESS = 63,
  SEED_PREVENT_CURSE_LABYRINTH = 64,
  SEED_PREVENT_CURSE_LOST = 65,
  SEED_PREVENT_CURSE_UNKNOWN = 66,
  SEED_PREVENT_CURSE_MAZE = 67,
  SEED_PREVENT_CURSE_BLIND = 68,
  SEED_PREVENT_ALL_CURSES = 70,
  SEED_NO_BOSS_ROOM_EXITS = 71,
  SEED_PICKUPS_TIMEOUT = 72,
  SEED_INVINCIBLE = 73,
  SEED_SHOOT_IN_MOVEMENT_DIRECTION = 74,
  SEED_SHOOT_OPPOSITE_MOVEMENT_DIRECTION = 75,
  SEED_AXIS_ALIGNED_CONTROLS = 76,
  SEED_SUPER_HOT = 77,
  SEED_RETRO_VISION = 78,
  NUM_SEEDS = 79,
}

declare enum GridRooms {
  NO_ROOM_IDX = -99999,
  ROOM_DEVIL_IDX = -1,
  ROOM_ERROR_IDX = -2,
  ROOM_DEBUG_IDX = -3,
  ROOM_DUNGEON_IDX = -4,
  ROOM_BOSSRUSH_IDX = -5,
  ROOM_BLACK_MARKET_IDX = -6,
  ROOM_MEGA_SATAN_IDX = -7,
  ROOM_BLUE_WOOM_IDX = -8,
  ROOM_THE_VOID_IDX = -9,
  ROOM_SECRET_EXIT_IDX = -10,
  ROOM_GIDEON_DUNGEON_IDX = -11,
  ROOM_GENESIS_IDX = -12,
  ROOM_SECRET_SHOP_IDX = -13,
  ROOM_ROTGUT_DUNGEON1_IDX = -14,
  ROOM_ROTGUT_DUNGEON2_IDX = -15,
  ROOM_BLUE_ROOM_IDX = -16,
  ROOM_EXTRA_BOSS_IDX = -17,
  ROOM_ANGEL_SHOP_IDX = -18,
  NUM_OFF_GRID_ROOMS = 18,
  MAX_GRID_ROOMS = 507,
  MAX_ROOMS = 525,
  ROOM_MIRROR_IDX = -100,
  ROOM_MINESHAFT_IDX = -101,
}

declare enum ItemPoolType {
  POOL_NULL = -1,
  POOL_TREASURE = 0,
  POOL_SHOP = 1,
  POOL_BOSS = 2,
  POOL_DEVIL = 3,
  POOL_ANGEL = 4,
  POOL_SECRET = 5,
  POOL_LIBRARY = 6,
  POOL_SHELL_GAME = 7,
  POOL_GOLDEN_CHEST = 8,
  POOL_RED_CHEST = 9,
  POOL_BEGGAR = 10,
  POOL_DEMON_BEGGAR = 11,
  POOL_CURSE = 12,
  POOL_KEY_MASTER = 13,
  POOL_BATTERY_BUM = 14,
  POOL_MOMS_CHEST = 15,
  POOL_GREED_TREASUREL = 16,
  POOL_GREED_BOSS = 17,
  POOL_GREED_SHOP = 18,
  POOL_GREED_DEVIL = 19,
  POOL_GREED_ANGEL = 20,
  POOL_GREED_CURSE = 21,
  POOL_GREED_SECRET = 22,
  POOL_CRANE_GAME = 23,
  POOL_24 = 24,
  POOL_BOMB_BUM = 25,
  POOL_PLANETARIUM = 26,
  POOL_OLD_CHEST = 27,
  POOL_BABY_SHOP = 28,
  POOL_WOODEN_CHEST = 29,
  POOL_ROTTEN_BEGGAR = 30,
  NUM_ITEMPOOLS = 31,
}

declare enum EntityPartition {
  FAMILIAR = 1,
  BULLET = 1 << 1,
  TEAR = 1 << 2,
  ENEMY = 1 << 3,
  PICKUP = 1 << 4,
  PLAYER = 1 << 5,
  EFFECT = 1 << 6,
}

declare enum ChampionColor {
  /** 33% more life. Drops a red heart. */
  RED = 0,
  /** 33% increased movement speed. Drops a Lil Battery. */
  YELLOW = 1,
  /** Leaves green creep as it walks. Drops a pill. */
  GREEN = 2,
  /** Greed shot (causing dropped coins on hit). Drops 1-3 coins. */
  ORANGE = 3,
  /** Half speed. Spawns 3 blue flies on death. */
  BLUE = 4,
  /** Explodes on death. Drops a bomb. */
  BLACK = 5,
  /** Invincible until all other enemies are killed. Drops an eternal heart. */
  WHITE = 6,
  /** 33% health, half speed. Drops a key. */
  GREY = 7,
  /** Spectral projectiles and can move past environmental obstacles. Drops a locked chest. */
  TRANSPARENT = 8,
  /** Fades in and out of visibility. Drops a red chest. */
  FLICKER = 9,
  /** Random projectiles. No drop. */
  PINK = 10,
  /** Pulls the player (and tears) towards itself. Drops a trinket. */
  PURPLE = 11,
  /**
   * Collapses into a flesh pile upon death and regenerates if not finished off.
   * Drops a double heart.
   */
  DARK_RED = 12,
  /** Releases blood shots in 8 directions when killed. Drops a half red heart. */
  LIGHT_BLUE = 13,
  /**
   * The enemy blends into the background and briefly becomes visible when damaged.
   * Drops a rune.
   */
  CAMO = 14,
  /** Splits into two copies of itself upon death. */
  PULSE_GREEN = 15,
  /** Repels Isaac's tears while in the gray state. Drops a random pickup. */
  PULSE_GREY = 16,
  /** Has 1-2 Eternal Flies circling it. Spawns two attack flies on death. */
  FLY_PROTECTED = 17,
  /** Half size, 33% less HP, 33% faster. 20% chance to drop a pill. */
  TINY = 18,
  /** Double size, 50% more HP, does 2 hearts of damage, 10% slower. 20% chance to drop a pill. */
  GIANT = 19,
  /** Heals all enemies in the room (including itself) for 30 HP per second. Drops a heart. */
  PULSE_RED = 20,
  /**
   * Spawns an Attack Fly on hit. After each hit, there is a delay until the next hit results in
   * another Attack Fly. A single Pulsating enemy can have up to 5 Attack Flies at once.
   * Spawns 4-6 blue flies on death.
   */
  SIZE_PULSE = 21,
  /**
   * 3x HP. All enemies in the room that are not champions will turn yellow while the crowned enemy
   * is alive. The affected enemies will drop batteries like yellow champions upon dying.
   * Drops 2-3 random pickups.
   */
  KING = 22,
  /**
   * Does 2 hearts of damage when touched. Produces a Necronomicon effect upon death.
   * Deals two full hearts of damage.
   */
  DEATH = 23,
  /** Constantly poops. */
  BROWN = 24,
  /** Many champion effects combined, drops one of everything. */
  RAINBOW = 25,
}

declare enum ActiveSlot {
  /** The main slot for active items, in the top-left-hand corner. */
  SLOT_PRIMARY = 0,
  /** The SchoolBag slot, to the top-left of the active item. */
  SLOT_SECONDARY = 1,
  /** The permanent card/pill slot. (Several Tainted characters use this slot.) */
  SLOT_POCKET = 2,
  /** A single use card/pill slot (used by Dice Bag). */
  SLOT_POCKET2 = 3,
}

declare enum RoomTransitionAnim {
  /** Mostly when using doors. */
  WALK = 0,
  /** The fade-in / fade-out used for Mom's Hand. */
  FADE = 1,
  /** The fade + pixelation effect used for secret item dungeon. */
  PIXELATION = 2,
  TELEPORT = 3,
  /** For Curse of the Maze. */
  MAZE = 4,
  ANKH = 5,
  DEAD_CAT = 6,
  ONE_UP = 7,
  COLLAR = 8,
  JUDAS_SHADOW = 9,
  LAZARUS = 10,
  /** For the Ventricle Razor teleport. */
  WOMB_TELEPORT = 11,
  /** For the Glowing Hour Glass teleport. */
  GLOWING_HOURGLASS = 12,
  D7 = 13,
  MISSING_POSTER = 14,
  /** No transition; goes directly to the boss intro cutscene (for the Backasswards challenge). */
  BOSS_FORCED = 15,
  /** For a Card Reading teleport. */
  PORTAL_TELEPORT = 16,
  /** For the Forgotten's Birthright effect. */
  FORGOTTEN_TELEPORT = 17,
  FADE_MIRROR = 18,
  MINECART = 19,
  DEATH_CERTIFICATE = 20,
}

declare enum BackdropType {
  BACKDROP_NULL = 0,
  BASEMENT = 1,
  CELLAR = 2,
  BURNT_BASEMENT = 3,
  CAVES = 4,
  CATACOMBS = 5,
  FLOODED_CAVES = 6,
  DEPTHS = 7,
  NECROPOLIS = 8,
  DANK_DEPTHS = 9,
  WOMB = 10,
  UTERO = 11,
  SCARRED_WOMB = 12,
  BLUE_WOMB = 13,
  SHEOL = 14,
  CATHEDRAL = 15,
  DARKROOM = 16,
  CHEST = 17,
  MEGA_SATAN = 18,
  LIBRARY = 19,
  SHOP = 20,
  ISAAC = 21,
  BARREN = 22,
  SECRET = 23,
  DICE = 24,
  ARCADE = 25,
  ERROR_ROOM = 26,
  BLUE_WOMB_PASS = 27,
  GREED_SHOP = 28,
  DUNGEON = 29,
  SACRIFICE = 30,
  DOWNPOUR = 31,
  MINES = 32,
  MAUSOLEUM = 33,
  CORPSE = 34,
  PLANETARIUM = 35,
  DOWNPOUR_ENTRANCE = 36,
  MINES_ENTRANCE = 37,
  MAUSOLEUM_ENTRANCE = 38,
  CORPSE_ENTRANCE = 39,
  MAUSOLEUM2 = 40,
  MAUSOLEUM3 = 41,
  MAUSOLEUM4 = 42,
  CORPSE2 = 43,
  CORPSE3 = 44,
  DROSS = 45,
  ASHPIT = 46,
  GEHENNA = 47,
  MORTIS = 48,
  ISAACS_BEDROOM = 49,
  HALLWAY = 50,
  MOMS_BEDROOM = 51,
  CLOSET = 52,
  CLOSET_B = 53,
  DOGMA = 54,
  DUNGEON_GIDEON = 55,
  DUNGEON_ROTGUT = 56,
  DUNGEON_BEAST = 57,
  MINES_SHAFT = 58,
  ASHPIT_SHAFT = 59,
  DARK_CLOSET = 60,
  NUM_BACKDROPS = 61,
  CHARGE_NORMAL = 0,
  CHARGE_TIMED = 1,
  CHARGE_SPECIAL = 2,
  TAG_DEAD = 1,
  TAG_SYRINGE = 1 << 1,
  TAG_MOM = 1 << 2,
  TAG_TECH = 1 << 3,
  TAG_BATTERY = 1 << 4,
  TAG_GUPPY = 1 << 5,
  TAG_FLY = 1 << 6,
  TAG_BOB = 1 << 7,
  TAG_MUSHROOM = 1 << 8,
  TAG_BABY = 1 << 9,
  TAG_ANGEL = 1 << 10,
  TAG_DEVIL = 1 << 11,
  TAG_POOP = 1 << 12,
  TAG_BOOK = 1 << 13,
  TAG_SPIDER = 1 << 14,
  TAG_QUEST = 1 << 15,
  TAG_MONSTER_MANUAL = 1 << 16,
  TAG_NO_GREED = 1 << 17,
  TAG_FOOD = 1 << 18,
  TAG_TEARS_UP = 1 << 19,
  TAG_OFFENSIVE = 1 << 20,
  TAG_NO_KEEPER = 1 << 21,
  TAG_NO_LOST_BR = 1 << 22,
  TAG_STARS = 1 << 23,
  TAG_SUMMONABLE = 1 << 24,
  TAG_NO_CANTRIP = 1 << 25,
  TAG_WISP = 1 << 26,
  TAG_UNIQUE_FAMILIAR = 1 << 27,
  CARDTYPE_TAROT = 0,
  CARDTYPE_SUIT = 1,
  CARDTYPE_RUNE = 2,
  CARDTYPE_SPECIAL_OBJECT = 4,
  CARDTYPE_TAROT_REVERSE = 5,
}
