// Enums from the "resources/scripts/enums.lua" file
// (entity variants only)

/** For EntityType.TEAR (2) */
declare enum TearVariant {
  BLUE = 0,
  BLOOD = 1,
  TOOTH = 2,
  METALLIC = 3,
  BOBS_HEAD = 4,
  FIRE_MIND = 5,
  DARK_MATTER = 6,
  MYSTERIOUS = 7,
  SCHYTHE = 8,
  CHAOS_CARD = 9,
  LOST_CONTACT = 10,
  CUPID_BLUE = 11,
  CUPID_BLOOD = 12,
  NAIL = 13,
  PUPULA = 14,
  PUPULA_BLOOD = 15,
  GODS_FLESH = 16,
  GODS_FLESH_BLOOD = 17,
  DIAMOND = 18,
  EXPLOSIVO = 19,
  COIN = 20,
  MULTIDIMENSIONAL = 21,
  STONE = 22,
  NAIL_BLOOD = 23,
  GLAUCOMA = 24,
  GLAUCOMA_BLOOD = 25,
  BOOGER = 26,
  EGG = 27,
  RAZOR = 28,
  BONE = 29,
  BLACK_TOOTH = 30,
  NEEDLE = 31,
  BELIAL = 32,
  EYE = 33,
  EYE_BLOOD = 34,
  BALLOON = 35,
  HUNGRY = 36,
  BALLOON_BRIMSTONE = 37,
  BALLOON_BOMB = 38,
  FIST = 39,
  GRIDENT = 40,
  ICE = 41,
  ROCK = 42,
  KEY = 43,
  KEY_BLOOD = 44,
  ERASER = 45,
  FIRE = 46,
  SWORD_BEAM = 47,
  SPORE = 48,
  TECH_SWORD_BEAM = 49,
}

/** For EntityType.ENTITY_FAMILIAR (3) */
declare enum FamiliarVariant {
  FAMILIAR_NULL = 0,
  BROTHER_BOBBY = 1,
  DEMON_BABY = 2,
  LITTLE_CHUBBY = 3,
  LITTLE_GISH = 4,
  LITTLE_STEVEN = 5,
  ROBO_BABY = 6,
  SISTER_MAGGY = 7,
  ABEL = 8,
  GHOST_BABY = 9,
  HARLEQUIN_BABY = 10,
  RAINBOW_BABY = 11,
  ISAACS_HEAD = 12,
  BLUE_BABY_SOUL = 13,
  DEAD_BIRD = 14,
  EVES_BIRD_FOOT = 15,
  DADDY_LONGLEGS = 16,
  PEEPER = 17,
  BOMB_BAG = 20,
  SACK_OF_PENNIES = 21,
  LITTLE_CHAD = 22,
  RELIC = 23,
  BUM_FRIEND = 24,
  HOLY_WATER = 25,
  KEY_PIECE_1 = 26,
  KEY_PIECE_2 = 27,
  KEY_FULL = 28,
  FOREVER_ALONE = 30,
  DISTANT_ADMIRATION = 31,
  GUARDIAN_ANGEL = 32,
  FLY_ORBITAL = 33,
  SACRIFICIAL_DAGGER = 35,
  DEAD_CAT = 40,
  ONE_UP = 41,
  GUPPYS_HAIRBALL = 42,
  BLUE_FLY = 43,
  CUBE_OF_MEAT_1 = 44,
  CUBE_OF_MEAT_2 = 45,
  CUBE_OF_MEAT_3 = 46,
  CUBE_OF_MEAT_4 = 47,
  ISAACS_BODY = 48,
  SMART_FLY = 50,
  DRY_BABY = 51,
  JUICY_SACK = 52,
  ROBO_BABY_2 = 53,
  ROTTEN_BABY = 54,
  HEADLESS_BABY = 55,
  LEECH = 56,
  MYSTERY_SACK = 57,
  BBF = 58,
  BOBS_BRAIN = 59,
  BEST_BUD = 60,
  LIL_BRIMSTONE = 61,
  ISAACS_HEART = 62,
  LIL_HAUNT = 63,
  DARK_BUM = 64,
  BIG_FAN = 65,
  SISSY_LONGLEGS = 66,
  PUNCHING_BAG = 67,
  GUILLOTINE = 68,
  BALL_OF_BANDAGES_1 = 69,
  BALL_OF_BANDAGES_2 = 70,
  BALL_OF_BANDAGES_3 = 71,
  BALL_OF_BANDAGES_4 = 72,
  BLUE_SPIDER = 73,
  MONGO_BABY = 74,
  SAMSONS_CHAINS = 75,
  CAINS_OTHER_EYE = 76,
  BLUEBABYS_ONLY_FRIEND = 77,
  SCISSORS = 78,
  GEMINI = 79,
  INCUBUS = 80,
  FATES_REWARD = 81,
  LIL_CHEST = 82,
  SWORN_PROTECTOR = 83,
  FRIEND_ZONE = 84,
  LOST_FLY = 85,
  CHARGED_BABY = 86,
  LIL_GURDY = 87,
  BUMBO = 88,
  CENSER = 89,
  KEY_BUM = 90,
  RUNE_BAG = 91,
  SERAPHIM = 92,
  GB_BUG = 93,
  SPIDER_MOD = 94,
  FARTING_BABY = 95,
  SUCCUBUS = 96,
  LIL_LOKI = 97,
  OBSESSED_FAN = 98,
  PAPA_FLY = 99,
  MILK = 100,
  MULTIDIMENSIONAL_BABY = 101,
  SUPER_BUM = 102,
  TONSIL = 103,
  BIG_CHUBBY = 104,
  DEPRESSION = 105,
  SHADE = 106,
  HUSHY = 107,
  LIL_MONSTRO = 108,
  KING_BABY = 109,
  FINGER = 110,
  YO_LISTEN = 111,
  ACID_BABY = 112,
  SPIDER_BABY = 113,
  SACK_OF_SACKS = 114,
  BROWN_NUGGET_POOTER = 115,
  BLOODSHOT_EYE = 116,
  MOMS_RAZOR = 117,
  ANGRY_FLY = 118,
  BUDDY_IN_A_BOX = 119,
  SPRINKLER = 120,
  LEPROSY = 121,
  LIL_HARBINGERS = 122,
  ANGELIC_PRISM = 123,
  MYSTERY_EGG = 124,
  LIL_SPEWER = 125,
  SLIPPED_RIB = 126,
  POINTY_RIB = 127,
  BONE_ORBITAL = 128,
  HALLOWED_GROUND = 129,
  JAW_BONE = 130,
  INTRUDER = 200,
  DIP = 201,
  DAMOCLES = 202,
  BLOOD_OATH = 203,
  PSY_FLY = 204,
  MENORAH = 205,
  WISP = 206,
  PEEPER_2 = 207,
  BOILED_BABY = 208,
  FREEZER_BABY = 209,
  BIRD_CAGE = 210,
  LOST_SOUL = 211,
  LIL_DUMPY = 212,
  KNIFE_PIECE_1 = 213,
  KNIFE_PIECE_2 = 214,
  TINYTOMA = 216,
  TINYTOMA_2 = 217,
  BOT_FLY = 218,
  SIREN_MINION = 220,
  PASCHAL_CANDLE = 221,
  STITCHES = 222,
  KNIFE_FULL = 223,
  BABY_PLUM = 224,
  FRUITY_PLUM = 225,
  SPIN_TO_WIN = 226,
  MINISAAC = 228,
  SWARM_FLY_ORBITAL = 229,
  LIL_ABADDON = 230,
  ABYSS_LOCUST = 231,
  LIL_PORTAL = 232,
  WORM_FRIEND = 233,
  BONE_SPUR = 234,
  TWISTED_BABY = 235,
  STAR_OF_BETHLEHEM = 236,
  ITEM_WISP = 237,
  BLOOD_BABY = 238,
  CUBE_BABY = 239,
  UMBILICAL_BABY = 240,
  BLOOD_PUPPY = 241,
  VANISHING_TWIN = 242,
  DECAP_ATTACK = 243,
  FORGOTTEN_BODY = 900,
}

/** For EntityType.ENTITY_BOMBDROP (4) */
declare enum BombVariant {
  BOMB_NORMAL = 0,
  BOMB_BIG = 1,
  BOMB_DECOY = 2,
  BOMB_TROLL = 3,
  BOMB_SUPERTROLL = 4,
  BOMB_POISON = 5,
  BOMB_POISON_BIG = 6,
  BOMB_SAD = 7,
  BOMB_HOT = 8,
  BOMB_BUTT = 9,
  BOMB_MR_MEGA = 10,
  BOMB_BOBBY = 11,
  BOMB_GLITTER = 12,
  BOMB_THROWABLE = 13,
  BOMB_SMALL = 14,
  BOMB_BRIMSTONE = 15,
  BOMB_SAD_BLOOD = 16,
  BOMB_GIGA = 17,
  BOMB_GOLDENTROLL = 18,
  BOMB_ROCKET = 19,
  BOMB_ROCKET_GIGA = 20,
}

/** For EntityType.ENTITY_PICKUP (5) */
declare enum PickupVariant {
  PICKUP_NULL = 0,
  PICKUP_HEART = 10,
  PICKUP_COIN = 20,
  PICKUP_KEY = 30,
  PICKUP_BOMB = 40,
  PICKUP_THROWABLEBOMB = 41,
  PICKUP_POOP = 42,
  PICKUP_CHEST = 50,
  PICKUP_BOMBCHEST = 51,
  PICKUP_SPIKEDCHEST = 52,
  PICKUP_ETERNALCHEST = 53,
  PICKUP_MIMICCHEST = 54,
  PICKUP_OLDCHEST = 55,
  PICKUP_WOODENCHEST = 56,
  PICKUP_MEGACHEST = 57,
  PICKUP_HAUNTEDCHEST = 58,
  PICKUP_LOCKEDCHEST = 60,
  PICKUP_GRAB_BAG = 69,
  PICKUP_PILL = 70,
  PICKUP_LIL_BATTERY = 90,
  PICKUP_COLLECTIBLE = 100,
  PICKUP_SHOPITEM = 150,
  PICKUP_TAROTCARD = 300,
  PICKUP_BIGCHEST = 340,
  PICKUP_TRINKET = 350,
  PICKUP_REDCHEST = 360,
  PICKUP_TROPHY = 370,
  PICKUP_BED = 380,
  PICKUP_MOMSCHEST = 390,
}

/** For EntityType.ENTITY_PROJECTILE (9) */
declare enum ProjectileVariant {
  PROJECTILE_NORMAL = 0,
  PROJECTILE_BONE = 1,
  PROJECTILE_FIRE = 2,
  PROJECTILE_PUKE = 3,
  PROJECTILE_TEAR = 4,
  PROJECTILE_CORN = 5,
  PROJECTILE_HUSH = 6,
  PROJECTILE_COIN = 7,
  PROJECTILE_GRID = 8,
  PROJECTILE_ROCK = 9,
  PROJECTILE_RING = 10,
  PROJECTILE_MEAT = 11,
  PROJECTILE_FCUK = 12,
  PROJECTILE_WING = 13,
  PROJECTILE_LAVA = 14,
  PROJECTILE_HEAD = 15,
  PROJECTILE_PEEP = 16,
}

/** For EntityType.ENTITY_EFFECT (1000) */
declare enum EffectVariant {
  EFFECT_NULL = 0,
  BOMB_EXPLOSION = 1,
  BLOOD_EXPLOSION = 2,
  FLY_EXPLOSION = 3,
  ROCK_PARTICLE = 4,
  BLOOD_PARTICLE = 5,
  DEVIL = 6,
  BLOOD_SPLAT = 7,
  LADDER = 8,
  ANGEL = 9,
  BLUE_FLAME = 10,
  BULLET_POOF = 11,
  TEAR_POOF_A = 12,
  TEAR_POOF_B = 13,
  RIPPLE_POOF = 14,
  CROSS_POOF = 14,
  POOF01 = 15,
  POOF02 = 16,
  POOF04 = 17,
  BOMB_CRATER = 18,
  CRACK_THE_SKY = 19,
  SCYTHE_BREAK = 20,
  TINY_BUG = 21,
  CREEP_RED = 22,
  CREEP_GREEN = 23,
  CREEP_YELLOW = 24,
  CREEP_WHITE = 25,
  CREEP_BLACK = 26,
  WOOD_PARTICLE = 27,
  MONSTROS_TOOTH = 28,
  MOM_FOOT_STOMP = 29,
  TARGET = 30,
  ROCKET = 31,
  PLAYER_CREEP_LEMON_MISHAP = 32,
  TINY_FLY = 33,
  FART = 34,
  TOOTH_PARTICLE = 35,
  XRAY_WALL = 36,
  PLAYER_CREEP_HOLYWATER = 37,
  SPIDER_EXPLOSION = 38,
  HEAVEN_LIGHT_DOOR = 39,
  STARFLASH = 40,
  WATER_DROPLET = 41,
  BLOOD_GUSH = 42,
  POOP_EXPLOSION = 43,
  PLAYER_CREEP_WHITE = 44,
  PLAYER_CREEP_BLACK = 45,
  PLAYER_CREEP_RED = 46,
  TRINITY_SHIELD = 47,
  BATTERY = 48,
  HEART = 49,
  LASER_IMPACT = 50,
  HOT_BOMB_FIRE = 51,
  RED_CANDLE_FLAME = 52,
  PLAYER_CREEP_GREEN = 53,
  PLAYER_CREEP_HOLYWATER_TRAIL = 54,
  SPIKE = 55,
  CREEP_BROWN = 56,
  PULLING_EFFECT = 57,
  POOP_PARTICLE = 58,
  DUST_CLOUD = 59,
  BOOMERANG = 60,
  SHOCKWAVE = 61,
  ROCK_EXPLOSION = 62,
  WORM = 63,
  BEETLE = 64,
  WISP = 65,
  EMBER_PARTICLE = 66,
  SHOCKWAVE_DIRECTIONAL = 67,
  WALL_BUG = 68,
  BUTTERFLY = 69,
  BLOOD_DROP = 70,
  BRIMSTONE_SWIRL = 71,
  CRACKWAVE = 72,
  SHOCKWAVE_RANDOM = 73,
  ISAACS_CARPET = 74,
  BAR_PARTICLE = 75,
  DICE_FLOOR = 76,
  LARGE_BLOOD_EXPLOSION = 77,
  PLAYER_CREEP_LEMON_PARTY = 78,
  TEAR_POOF_SMALL = 79,
  TEAR_POOF_VERYSMALL = 80,
  FRIEND_BALL = 81,
  WOMB_TELEPORT = 82,
  SPEAR_OF_DESTINY = 83,
  EVIL_EYE = 84,
  DIAMOND_PARTICLE = 85,
  NAIL_PARTICLE = 86,
  FALLING_EMBER = 87,
  DARK_BALL_SMOKE_PARTICLE = 88,
  ULTRA_GREED_FOOTPRINT = 89,
  PLAYER_CREEP_PUDDLE_MILK = 90,
  MOMS_HAND = 91,
  PLAYER_CREEP_BLACKPOWDER = 92,
  PENTAGRAM_BLACKPOWDER = 93,
  CREEP_SLIPPERY_BROWN = 94,
  GOLD_PARTICLE = 95,
  HUSH_LASER = 96,
  IMPACT = 97,
  COIN_PARTICLE = 98,
  WATER_SPLASH = 99,
  HUSH_ASHES = 100,
  HUSH_LASER_UP = 101,
  BULLET_POOF_HUSH = 102,
  ULTRA_GREED_BLING = 103,
  FIREWORKS = 104,
  BROWN_CLOUD = 105,
  FART_RING = 106,
  BLACK_HOLE = 107,
  MR_ME = 108,
  DEATH_SKULL = 109,
  ENEMY_BRIMSTONE_SWIRL = 110,
  HAEMO_TRAIL = 111,
  HALLOWED_GROUND = 112,
  BRIMSTONE_BALL = 113,
  FORGOTTEN_CHAIN = 114,
  BROKEN_SHOVEL_SHADOW = 115,
  DIRT_PATCH = 116,
  FORGOTTEN_SOUL = 117,
  SMALL_ROCKET = 118,
  TIMER = 119,
  SPAWNER = 120,
  LIGHT = 121,
  BIG_HORN_HOLE_HELPER = 122,
  HALO = 123,
  TAR_BUBBLE = 124,
  BIG_HORN_HAND = 125,
  TECH_DOT = 126,
  MAMA_MEGA_EXPLOSION = 127,
  OPTION_LINE = 128,
  LEECH_EXPLOSION = 130,
  MAGGOT_EXPLOSION = 131,
  BIG_SPLASH = 132,
  WATER_RIPPLE = 133,
  PEDESTAL_RIPPLE = 134,
  RAIN_DROP = 135,
  GRID_ENTITY_PROJECTILE_HELPER = 136,
  WORMWOOD_HOLE = 137,
  MIST = 138,
  TRAPDOOR_COVER = 139,
  BACKDROP_DECORATION = 140,
  SMOKE_CLOUD = 141,
  WHIRLPOOL = 142,
  FARTWAVE = 143,
  ENEMY_GHOST = 144,
  ROCK_POOF = 145,
  DIRT_PILE = 146,
  FIRE_JET = 147,
  FIRE_WAVE = 148,
  BIG_ROCK_EXPLOSION = 149,
  BIG_CRACKWAVE = 150,
  BIG_ATTRACT = 151,
  HORNFEL_ROOM_CONTROLLER = 152,
  OCCULT_TARGET = 153,
  DOOR_OUTLINE = 154,
  CREEP_SLIPPERY_BROWN_GROWING = 155,
  TALL_LADDER = 156,
  WILLO_SPAWNER = 157,
  TADPOLE = 158,
  LIL_GHOST = 159,
  BISHOP_SHIELD = 160,
  PORTAL_TELEPORT = 161,
  HERETIC_PENTAGRAM = 162,
  CHAIN_GIB = 163,
  SIREN_RING = 164,
  CHARM_EFFECT = 165,
  SPRITE_TRAIL = 166,
  CHAIN_LIGHTNING = 167,
  COLOSTOMIA_PUDDLE = 168,
  CREEP_STATIC = 169,
  DOGMA_DEBRIS = 170,
  DOGMA_BLACKHOLE = 171,
  DOGMA_ORB = 172,
  CRACKED_ORB_POOF = 173,
  SHOP_SPIKES = 174,
  KINETI_BEAM = 175,
  CLEAVER_SLASH = 176,
  REVERSE_EXPLOSION = 177,
  URN_OF_SOULS = 178,
  ENEMY_SOUL = 179,
  RIFT = 180,
  LAVA_SPAWNER = 181,
  BIG_KNIFE = 182,
  MOTHER_SHOCKWAVE = 183,
  WORM_FRIEND_SNARE = 184,
  REDEMPTION = 185,
  HUNGRY_SOUL = 186,
  EXPLOSION_WAVE = 187,
  DIVINE_INTERVENTION = 188,
  PURGATORY = 189,
  MOTHER_TRACER = 190,
  PICKUP_GHOST = 191,
  FISSURE_SPAWNER = 192,
  ANIMA_CHAIN = 193,
  DARK_SNARE = 194,
  CREEP_LIQUID_POOP = 195,
  GROUND_GLOW = 196,
  DEAD_BIRD = 197,
  GENERIC_TRACER = 198,
  ULTRA_DEATH_SCYTHE = 199,
}

/** For GridEntityType.GRID_DOOR (16) */
declare enum DoorVariant {
  DOOR_UNSPECIFIED = 0,
  DOOR_LOCKED = 1,
  DOOR_LOCKED_DOUBLE = 2,
  DOOR_LOCKED_CRACKED = 3,
  DOOR_LOCKED_BARRED = 4,
  DOOR_LOCKED_KEYFAMILIAR = 5,
  DOOR_LOCKED_GREED = 6,
  DOOR_HIDDEN = 7,
  DOOR_UNLOCKED = 8,
}
