/** Matches the IDs in the "specialrooms.stb" file. */
declare const enum BossIDs {
  MONSTRO = 1,
  LARRY_JR = 2,
  CHUB = 3,
  GURDY = 4,
  MONSTRO_II = 5,
  MOM = 6,
  SCOLEX = 7,
  MOMS_HEART = 8,
  FAMINE = 9,
  PESTILENCE = 10,
  WAR = 11,
  DEATH = 12,
  DUKE_OF_FLIES = 13,
  PEEP = 14,
  LOKI = 15,
  BLASTOCYST = 16,
  GEMINI = 17,
  FISTULA = 18,
  GISH = 19,
  STEVEN = 20,
  CHAD = 21,
  HEADLESS_HORSEMAN = 22,
  THE_FALLEN = 23,
  SATAN = 24,
  IT_LIVES = 25,
  THE_HOLLOW = 26,
  THE_CARRION_QUEEN = 27,
  GURDY_JR = 28,
  THE_HUSK = 29,
  THE_BLOAT = 30,
  LOKII = 31,
  THE_BLIGHTED_OVUM = 32,
  TERATOMA = 33,
  THE_WIDOW = 34,
  MASK_OF_INFAMY = 35,
  THE_WRETCHED = 36,
  PIN = 37,
  CONQUEST = 38,
  ISAAC = 39,
  /** Also known as "???". */
  BLUE_BABY = 40,
  DADDY_LONG_LEGS = 41,
  TRIACHNID = 42,
  THE_HAUNT = 43,
  DINGLE = 44,
  MEGA_MAW = 45,
  MEGA_MAW_II = 46, // The Gate
  MEGA_FATTY = 47,
  MEGA_FATTY_II = 48, // The Cage
  MEGA_GURDY = 49,
  DARK_ONE = 50,
  DARK_ONE_II = 51, // The Adversary
  POLYCEPHALUS = 52,
  MEGA_FRED = 53,
  THE_LAMB = 54,
  MEGA_SATAN = 55,
  GURGLINGS = 56,
  THE_STAIN = 57,
  BROWNIE = 58,
  THE_FORSAKEN = 59,
  LITTLE_HORN = 60,
  RAG_MAN = 61,
  ULTRA_GREED = 62,
  HUSH = 63,
  DANGLE = 64,
  TURDLING = 65,
  THE_FRAIL = 66,
  RAG_MEGA = 67,
  SISTERS_VIS = 68,
  BIG_HORN = 69,
  DELIRIUM = 70,
  THE_MATRIARCH = 72,
  THE_PILE = 73,
  REAP_CREEP = 74,
  BEELZEBLUB = 75,
  WORMWOOD = 76,
  RAINMAKER = 77,
  THE_VISAGE = 78,
  THE_SIREN = 79,
  TUFF_TWINS = 80,
  THE_HERETIC = 81,
  HORNFEL = 82,
  GREAT_GIDEON = 83,
  BABY_PLUM = 84,
  THE_SCOURGE = 85,
  CHIMERA = 86,
  ROTGUT = 87,
  MOTHER = 88,
  MAUSOLEUM_MOM = 89,
  MAUSOLEUM_MOMS_HEART = 90,
  MIN_MIN = 91,
  CLOG = 92,
  SINGE = 93,
  BUMBINO = 94,
  COLOSTOMIA = 95,
  THE_SHELL = 96,
  TURDLET = 97,
  /** This boss is currently unfinished and there are no boss rooms for it. */
  RAGLICH = 98,
  /** Dogma does not have its own boss rooms; it appears in a normal room. */
  DOGMA = 99,
  /** The Beast does not have its own boss rooms; it appears in a crawlspace. */
  BEAST = 100,
  HORNY_BOYS = 101,
  /** This boss is currently unfinished and there are no boss rooms for it. */
  POSSESSOR = 102,
}

/** For RoomType.ROOM_DEVIL (14) */
declare const enum DevilRoomSubType {
  NORMAL = 0,
  NUMBER_SIX_TRINKET_ROOM = 1,
}

/** For RoomType.ROOM_ANGEL (15) */
declare const enum AngelRoomSubType {
  NORMAL = 0,
  SHOP = 1,
}

declare const enum StageID {
  SPECIAL_ROOMS = 0,
  BASEMENT = 1,
  CELLAR = 2,
  BURNING_BASEMENT = 3,
  CAVES = 4,
  CATACOMBS = 5,
  FLOODED_CAVES = 6,
  DEPTHS = 7,
  NECROPOLIS = 8,
  DANK_DEPTHS = 9,
  WOMB = 10,
  UTERO = 11,
  SCARRED_WOMB = 12,
  BLUE_WOMB = 13,
  SHEOL = 14,
  CATHEDRAL = 15,
  DARK_ROOM = 16,
  CHEST = 17,
  VOID = 26,
  DOWNPOUR = 27,
  DROSS = 28,
  MINES = 29,
  ASHPIT = 30,
  MAUSOLEUM = 31,
  GEHENNA = 32,
  CORPSE = 33,
  MORTIS = 34,
  HOME = 35,
  BACKWARDS = 36,
}

/** For StageID.HOME (35) */
declare const enum HomeRoomSubType {
  ISAACS_BEDROOM = 0,
  HALLWAY = 1,
  MOMS_BEDROOM = 2,
  LIVING_ROOM = 3,
  BEAST_ROOM = 4,
  CLOSET_RIGHT = 10,
  CLOSET_LEFT = 11,
  DEATH_CERTIFICATE_ENTRANCE = 33,
  DEATH_CERTIFICATE_ITEMS = 33,
}

/** For StageID.BACKWARDS (36) */
declare const enum BackwardsPathRoomSubType {
  EXIT = 0,
  BASEMENT = 1,
  CAVES = 4,
  DEPTHS = 7,
  DOWNPOUR = 27,
  MINES = 29,
  MAUSOLEUM = 31,
}

/** Matches the entries in the "cutscenes.xml" file. */
declare const enum Ending {
  INTRO = 1,
  CREDITS = 2,
  EPILOGUE = 3,
  WOMB_EDEN = 4,
  WOMB_RUBBER_CEMENT = 5,
  WOMB_NOOSE = 6,
  WOMB_WIRE_COAT_HANGER = 7,
  WOMB_EVERYTHING_IS_TERRIBLE = 8,
  WOMB_IPECAC = 9,
  WOMB_EXPERIMENTAL_TREATMENT = 10,
  WOMB_A_QUARTER = 11,
  WOMB_DR_FETUS = 12,
  WOMB_BLUE_BABY = 13,
  WOMB_IT_LIVES = 14,
  SHEOL = 15,
  CATHEDRAL = 16,
  CHEST = 17,
  DARK_ROOM = 18,
  MEGA_SATAN = 19,
  BLUE_WOMB = 20,
  GREED_MODE = 21,
  THE_VOID = 22,
  GREEDIER = 23,
  MOTHER = 24,
  DOGMA = 25,
  BEAST = 26,
}
